var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { computed, useSlots, watch, ref } from "vue";
import { baseSelectProps } from "./baseSelect.mjs";
import { SelectProps } from "element-plus/es/components/select/src/select.mjs";
import { ElSelect, ElOptionGroup, ElOption } from "element-plus/es/index.mjs";
import { SuffixIcon } from "../../suffix-icon/index.mjs";
import { More as ElIconMore } from "@element-plus/icons-vue";
import { isEmpty } from "pagoda-shared";
import { isFunction } from "lodash-unified";
import { usePickProps } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("base-select");
const __default__ = {
  name,
  inheritAttrs: false
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: baseSelectProps,
  emits: ["update:modelValue"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const slots = useSlots();
    const elSelectAttrs = usePickProps(props, SelectProps, {
      ignoreClassAndStyle: true
    });
    const elSelectCtx = ref();
    const queryStr = ref("");
    const suffixIcon = computed(() => {
      return props.onAdvancedSearch && !props.loading ? ElIconMore : "";
    });
    const elSelectSlots = computed(() => {
      return ["prefix", "empty"].filter((name2) => slots[name2]);
    });
    const getKey = (obj, key) => {
      return isFunction(key) ? key(obj) : obj[key];
    };
    const getGroupProps = (group) => {
      const label = getKey(group, props.groupLabelKey);
      const disabled = getKey(group, props.groupDisabledKey);
      return __spreadProps(__spreadValues({}, group), {
        label,
        disabled
      });
    };
    const getOptionProps = (option) => {
      const label = getKey(option, props.labelKey);
      const value = getKey(option, props.valueKey);
      const disabled = getKey(option, props.disabledKey);
      return __spreadProps(__spreadValues({}, option), {
        label,
        value: props.bindObject ? option : value,
        disabled
      });
    };
    const getGroupKey = (group) => {
      return getKey(group, props.groupLabelKey);
    };
    const getOptionKey = (option) => {
      return getKey(option, props.valueKey);
    };
    const getOptionLable = (option) => {
      return props.formatter ? props.formatter(option) : getKey(option, props.labelKey);
    };
    const handleAdvancedSearch = () => {
      var _a;
      if (props.disabled)
        return;
      (_a = props.onAdvancedSearch) == null ? void 0 : _a.call(props);
    };
    const handleUpdateModelValue = (val) => {
      const next = (newVal) => {
        emit("update:modelValue", newVal);
      };
      if (props.beforeInput) {
        props.beforeInput(val, next);
      } else {
        next(val);
      }
    };
    const handleRemote = (query) => {
      var _a;
      queryStr.value = query;
      (_a = props.remoteMethod) == null ? void 0 : _a.call(props, query);
    };
    watch(
      () => props.options,
      () => {
        var _a;
        if (props.onlyOneAutoSelect && props.options.length === 1 && isEmpty(props.modelValue) && ((_a = queryStr.value) == null ? void 0 : _a.length) === 0) {
          const [option] = props.options;
          const val = props.bindObject ? option : getKey(option, props.valueKey);
          handleUpdateModelValue(props.multiple ? [val] : val);
        }
      },
      {
        immediate: true
      }
    );
    __expose({
      elSelectCtx
    });
    const __returned__ = { name, props, emit, slots, elSelectAttrs, elSelectCtx, queryStr, suffixIcon, elSelectSlots, getKey, getGroupProps, getOptionProps, getGroupKey, getOptionKey, getOptionLable, handleAdvancedSearch, handleUpdateModelValue, handleRemote, get ElSelect() {
      return ElSelect;
    }, get ElOptionGroup() {
      return ElOptionGroup;
    }, get ElOption() {
      return ElOption;
    }, get SuffixIcon() {
      return SuffixIcon;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { renderList as _renderList, Fragment as _Fragment, openBlock as _openBlock, createElementBlock as _createElementBlock, mergeProps as _mergeProps, renderSlot as _renderSlot, toDisplayString as _toDisplayString, createTextVNode as _createTextVNode, withCtx as _withCtx, createBlock as _createBlock, normalizeProps as _normalizeProps, guardReactiveProps as _guardReactiveProps, createSlots as _createSlots, createVNode as _createVNode, normalizeClass as _normalizeClass, normalizeStyle as _normalizeStyle } from "vue";
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock($setup["SuffixIcon"], {
    class: _normalizeClass(["pagoda-base-select", _ctx.$attrs.class]),
    icon: $setup.suffixIcon,
    onIconClick: $setup.handleAdvancedSearch,
    style: _normalizeStyle(_ctx.$attrs.style),
    size: $setup.props.size
  }, {
    default: _withCtx(() => [
      _createVNode($setup["ElSelect"], _mergeProps($setup.elSelectAttrs, {
        "remote-method": $setup.handleRemote,
        "value-key": _ctx.valueKey,
        "onUpdate:modelValue": $setup.handleUpdateModelValue,
        ref: "elSelectCtx"
      }), _createSlots({
        default: _withCtx(() => [
          _ctx.group ? (_openBlock(true), _createElementBlock(
            _Fragment,
            { key: 0 },
            _renderList(_ctx.options, (groupItem) => {
              return _openBlock(), _createBlock(
                $setup["ElOptionGroup"],
                _mergeProps({
                  key: $setup.getGroupKey(groupItem),
                  ref_for: true
                }, $setup.getGroupProps(groupItem)),
                {
                  default: _withCtx(() => [
                    (_openBlock(true), _createElementBlock(
                      _Fragment,
                      null,
                      _renderList($setup.getKey(groupItem, _ctx.groupOptionsKey), (option) => {
                        return _openBlock(), _createBlock(
                          $setup["ElOption"],
                          _mergeProps({
                            key: $setup.getOptionKey(option),
                            ref_for: true
                          }, $setup.getOptionProps(option)),
                          {
                            default: _withCtx(() => [
                              $setup.slots.default ? _renderSlot(_ctx.$slots, "default", _mergeProps({
                                key: 0,
                                ref_for: true
                              }, option)) : (_openBlock(), _createElementBlock(
                                _Fragment,
                                { key: 1 },
                                [
                                  _createTextVNode(
                                    _toDisplayString($setup.getOptionLable(option)),
                                    1
                                    /* TEXT */
                                  )
                                ],
                                64
                                /* STABLE_FRAGMENT */
                              ))
                            ]),
                            _: 2
                            /* DYNAMIC */
                          },
                          1040
                          /* FULL_PROPS, DYNAMIC_SLOTS */
                        );
                      }),
                      128
                      /* KEYED_FRAGMENT */
                    ))
                  ]),
                  _: 2
                  /* DYNAMIC */
                },
                1040
                /* FULL_PROPS, DYNAMIC_SLOTS */
              );
            }),
            128
            /* KEYED_FRAGMENT */
          )) : (_openBlock(true), _createElementBlock(
            _Fragment,
            { key: 1 },
            _renderList(_ctx.options, (option) => {
              return _openBlock(), _createBlock(
                $setup["ElOption"],
                _mergeProps({
                  key: $setup.getOptionKey(option),
                  ref_for: true
                }, $setup.getOptionProps(option)),
                {
                  default: _withCtx(() => [
                    $setup.slots.default ? _renderSlot(_ctx.$slots, "default", _mergeProps({
                      key: 0,
                      ref_for: true
                    }, option)) : (_openBlock(), _createElementBlock(
                      _Fragment,
                      { key: 1 },
                      [
                        _createTextVNode(
                          _toDisplayString($setup.getOptionLable(option)),
                          1
                          /* TEXT */
                        )
                      ],
                      64
                      /* STABLE_FRAGMENT */
                    ))
                  ]),
                  _: 2
                  /* DYNAMIC */
                },
                1040
                /* FULL_PROPS, DYNAMIC_SLOTS */
              );
            }),
            128
            /* KEYED_FRAGMENT */
          ))
        ]),
        _: 2
        /* DYNAMIC */
      }, [
        _renderList($setup.elSelectSlots, (slotName) => {
          return {
            name: slotName,
            fn: _withCtx((scope) => [
              _renderSlot(_ctx.$slots, slotName, _normalizeProps(_guardReactiveProps(scope)))
            ])
          };
        })
      ]), 1040, ["value-key"])
    ]),
    _: 3
    /* FORWARDED */
  }, 8, ["icon", "style", "class", "size"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
