var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent, Fragment, Comment, isVNode, createVNode as _createVNode, createTextVNode as _createTextVNode } from "vue";
import { ElDropdown, ElDropdownMenu, ElDropdownItem, ElButton } from "element-plus/es/index.mjs";
import { Icon } from "../../icon/index.mjs";
import { ArrowDown } from "@element-plus/icons-vue";
import { createNamespace } from "../../utils/index.mjs";
import { isArray } from "lodash-unified";
const name = createNamespace("collapse-button");
const PdIcon = Icon;
const collapseButtonProps = {
  max: {
    type: Number,
    default: 3
  }
};
var stdin_default = defineComponent({
  name,
  props: collapseButtonProps,
  setup(props, {
    slots
  }) {
    function getButtons() {
      var _a;
      const defaultSlots = (_a = slots.default) == null ? void 0 : _a.call(slots);
      const buttons = [];
      if (!defaultSlots)
        return buttons;
      defaultSlots.forEach((vnode) => {
        if (vnode.type === Comment)
          return;
        if (vnode.type === Fragment) {
          if (isArray(vnode.children)) {
            vnode.children.forEach((v) => {
              if (isVNode(v)) {
                buttons.push(v);
              }
            });
          }
        } else {
          buttons.push(vnode);
        }
      });
      return buttons;
    }
    function renderCollapseController() {
      const renderDefaultController = () => _createVNode(ElButton, {
        "type": "primary"
      }, {
        default: () => [_createTextVNode("\u66F4\u591A\u6761\u4EF6"), _createVNode(PdIcon, {
          "class": "el-icon--right",
          "is": ArrowDown
        }, null)]
      });
      const renderController = slots["collapse-controller"] || renderDefaultController;
      return _createVNode("div", {
        "class": "pagoda-collapse-button__controller"
      }, [renderController()]);
    }
    function renderDropdown(overflowButton) {
      return _createVNode(ElDropdownMenu, null, {
        default: () => [overflowButton.map((btn) => {
          btn.props = __spreadProps(__spreadValues({}, btn.props), {
            link: false,
            type: "default"
          });
          return _createVNode(ElDropdownItem, {
            "class": "pagoda-collapse-button-dropdown-item"
          }, {
            default: () => [btn]
          });
        })]
      });
    }
    return () => {
      const buttons = getButtons();
      const outsideButtons = buttons.slice(0, props.max);
      const overflowButton = buttons.slice(props.max, buttons.length);
      return _createVNode("div", {
        "class": "pagoda-collapse-button"
      }, [...outsideButtons, Boolean(overflowButton.length) && _createVNode(ElDropdown, {
        "placement": "bottom",
        "class": "pagoda-collapse-button-dropdown"
      }, {
        default: () => [renderCollapseController()],
        dropdown: () => renderDropdown(overflowButton)
      })]);
    };
  }
});
export {
  collapseButtonProps,
  stdin_default as default
};
