var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import { defineComponent as _defineComponent } from "vue";
import { ref, inject, computed } from "vue";
import { Icon } from "../../icon/index.mjs";
import { Loading, Close, Check, Edit } from "@element-plus/icons-vue";
import {
  formContextKey,
  formItemContextKey
} from "element-plus/es/index.mjs";
import { wait, getProp } from "pagoda-shared";
import { cloneDeep } from "lodash-unified";
import { PagodaUiError } from "../../utils/error.mjs";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("form-edit-item");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  setup(__props, { expose: __expose }) {
    __expose();
    const elFormProvider = inject(formContextKey);
    const elFormItemProvider = inject(formItemContextKey);
    if (!elFormProvider || !elFormItemProvider) {
      throw new PagodaUiError(
        "Component FormEditItem",
        "\u8BE5\u7EC4\u4EF6\u5FC5\u987B\u7ED3\u5408 ElForm\u7EC4\u4EF6 \u548C ElFormItem\u7EC4\u4EF6 \u4F7F\u7528"
      );
    }
    let preValue;
    const submiting = ref(false);
    const editing = ref(false);
    const contentEl = ref();
    const prop = computed(() => elFormItemProvider.prop);
    const fieldValue = computed(() => {
      const model = elFormProvider == null ? void 0 : elFormProvider.model;
      if (!model || !prop.value) {
        return;
      }
      return getProp(model, prop.value).value;
    });
    const toNormalState = () => {
      editing.value = false;
      submiting.value = false;
    };
    const toEditingState = () => {
      editing.value = true;
      submiting.value = false;
    };
    const toSubmitingState = () => {
      editing.value = false;
      submiting.value = true;
    };
    const clearValidate = () => __async(this, null, function* () {
      elFormItemProvider.clearValidate();
      yield wait(60);
    });
    const handleEdit = () => {
      toEditingState();
      preValue = cloneDeep(fieldValue.value);
    };
    const handleCancel = () => __async(this, null, function* () {
      yield clearValidate();
      elFormProvider.emit("edit-cancel", prop.value, preValue);
      toNormalState();
    });
    const handleSave = () => __async(this, null, function* () {
      yield clearValidate();
      toSubmitingState();
      const saveSuccess = () => {
        toNormalState();
      };
      const saveError = () => {
        toEditingState();
      };
      elFormProvider.emit("edit-save", prop.value, saveSuccess, saveError);
    });
    const __returned__ = { name, elFormProvider, elFormItemProvider, get preValue() {
      return preValue;
    }, set preValue(v) {
      preValue = v;
    }, submiting, editing, contentEl, prop, fieldValue, toNormalState, toEditingState, toSubmitingState, clearValidate, handleEdit, handleCancel, handleSave, get Icon() {
      return Icon;
    }, get Loading() {
      return Loading;
    }, get Close() {
      return Close;
    }, get Check() {
      return Check;
    }, get Edit() {
      return Edit;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { renderSlot as _renderSlot, vShow as _vShow, createElementVNode as _createElementVNode, withDirectives as _withDirectives, normalizeClass as _normalizeClass, createVNode as _createVNode, openBlock as _openBlock, createElementBlock as _createElementBlock } from "vue";
const _hoisted_1 = { class: "pagoda-form-edit-item" };
const _hoisted_2 = {
  ref: "contentEl",
  class: "pagoda-form-edit-item__content"
};
const _hoisted_3 = { style: { "flex": "1" } };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createElementBlock("div", _hoisted_1, [
    _withDirectives(_createElementVNode(
      "span",
      _hoisted_2,
      [
        _renderSlot(_ctx.$slots, "default")
      ],
      512
      /* NEED_PATCH */
    ), [
      [_vShow, !$setup.editing && !$setup.submiting]
    ]),
    _withDirectives(_createElementVNode(
      "div",
      _hoisted_3,
      [
        _renderSlot(_ctx.$slots, "edit")
      ],
      512
      /* NEED_PATCH */
    ), [
      [_vShow, $setup.editing && !$setup.submiting]
    ]),
    _withDirectives(_createVNode($setup["Icon"], {
      class: _normalizeClass(["pagoda-form-edit-item-controller loading", { "is-loading": $setup.submiting }]),
      is: $setup.Loading
    }, null, 8, ["class", "is"]), [
      [_vShow, $setup.submiting]
    ]),
    _withDirectives(_createVNode($setup["Icon"], {
      class: "pagoda-form-edit-item-controller close",
      is: $setup.Close,
      onClick: $setup.handleCancel
    }, null, 8, ["is"]), [
      [_vShow, !$setup.submiting && $setup.editing]
    ]),
    _withDirectives(_createVNode($setup["Icon"], {
      class: "pagoda-form-edit-item-controller check",
      is: $setup.Check,
      onClick: $setup.handleSave
    }, null, 8, ["is"]), [
      [_vShow, !$setup.submiting && $setup.editing]
    ]),
    _withDirectives(_createVNode($setup["Icon"], {
      class: "pagoda-form-edit-item-controller edit",
      onClick: $setup.handleEdit,
      is: $setup.Edit
    }, null, 8, ["is"]), [
      [_vShow, !$setup.submiting && !$setup.editing]
    ])
  ]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
