var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { ref, reactive, useSlots, computed } from "vue";
import { useResizeObserver } from "@vueuse/core";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("form-table-layout");
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, {
  name
}), {
  __name: "form-table-layout",
  setup(__props, { expose: __expose }) {
    const slots = useSlots();
    const btnsPosition = reactive({
      display: "inline-block",
      verticalAlign: "top",
      marginLeft: 0
    });
    const tableAreaMarginTop = ref(0);
    const rootEl = ref();
    const formAreaEl = ref();
    useResizeObserver(rootEl, doLayout);
    const hasBeforeFormSlot = computed(() => {
      return Boolean(slots["before-form"]);
    });
    const hasAfterFormSlot = computed(() => {
      return Boolean(slots["after-form"]);
    });
    const hasFormSlot = computed(() => {
      return Boolean(slots.form);
    });
    const hasTableBtnsSlot = computed(() => {
      return Boolean(slots["table-btns"]);
    });
    const hasTableSlot = computed(() => {
      return Boolean(slots.table);
    });
    function doLayout() {
      if (hasFormSlot.value) {
        const elFormEl = formAreaEl.value.querySelector(".el-form");
        if (!elFormEl)
          return;
        const elFormItemsEl = Array.from(
          formAreaEl.value.querySelectorAll(
            ".el-form > .el-form-item"
          )
        );
        if (!elFormItemsEl[0])
          return;
        const {
          elFormItemLabelWidth,
          elFormItemWidth,
          formRowItemNums,
          lastRowItemNums,
          onlyOneRow
        } = getFormLayoutData(elFormEl, elFormItemsEl);
        btnsPosition.marginLeft = caculateBtnMarginLeft({
          elFormItemLabelWidth,
          elFormItemWidth,
          formRowItemNums,
          lastRowItemNums,
          onlyOneRow
        }) + "px";
        if (!hasTableBtnsSlot.value && !onlyOneRow && lastRowItemNums === 0) {
          tableAreaMarginTop.value = 20;
        } else {
          tableAreaMarginTop.value = 0;
        }
      }
    }
    function getFormLayoutData(elFormEl, elFormItemsEl) {
      const visibleElFormItemsEl = elFormItemsEl.filter((elFormItemEl) => {
        const style = getComputedStyle(elFormItemEl);
        return style.display !== "none";
      });
      const elFormInnerWidth = getInnerWidth(elFormEl);
      const elFormItem = visibleElFormItemsEl[0];
      const elFormItemLabel = elFormItem.querySelector(
        ".el-form-item__label"
      );
      const elFormItemLabelWidth = elFormItemLabel ? getOutsideWidth(elFormItemLabel) : 0;
      const elFormItemWidth = getOutsideWidth(elFormItem);
      const formRowItemNums = Math.floor(elFormInnerWidth / elFormItemWidth);
      const lastRowItemNums = visibleElFormItemsEl.length % formRowItemNums;
      const onlyOneRow = visibleElFormItemsEl.length < formRowItemNums;
      return {
        elFormItemLabelWidth,
        elFormItemWidth,
        formRowItemNums,
        lastRowItemNums,
        onlyOneRow
      };
    }
    function caculateBtnMarginLeft({
      elFormItemLabelWidth,
      elFormItemWidth,
      formRowItemNums,
      lastRowItemNums,
      onlyOneRow
    }) {
      if (onlyOneRow) {
        return elFormItemLabelWidth;
      }
      if (lastRowItemNums > 0) {
        return (formRowItemNums - lastRowItemNums - 1) * elFormItemWidth + elFormItemLabelWidth;
      }
      return (formRowItemNums - 1) * elFormItemWidth + elFormItemLabelWidth;
    }
    function getInnerWidth(el) {
      const elStyle = getComputedStyle(el);
      const elInnerWidth = el.clientWidth - window.parseInt(elStyle.paddingLeft) - window.parseInt(elStyle.paddingRight);
      return elInnerWidth;
    }
    function getOutsideWidth(el) {
      const elStyle = getComputedStyle(el);
      const outsideWidth = window.parseInt(elStyle.marginLeft) + window.parseInt(elStyle.marginRight) + el.offsetWidth;
      return outsideWidth;
    }
    __expose({
      doLayout
    });
    const __returned__ = { name, slots, btnsPosition, tableAreaMarginTop, rootEl, formAreaEl, hasBeforeFormSlot, hasAfterFormSlot, hasFormSlot, hasTableBtnsSlot, hasTableSlot, doLayout, getFormLayoutData, caculateBtnMarginLeft, getInnerWidth, getOutsideWidth };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { renderSlot as _renderSlot, openBlock as _openBlock, createElementBlock as _createElementBlock, createCommentVNode as _createCommentVNode, normalizeStyle as _normalizeStyle } from "vue";
const _hoisted_1 = {
  class: "pagoda-form-table-layout",
  ref: "rootEl"
};
const _hoisted_2 = {
  key: 0,
  class: "pagoda-form-table-layout__before-form-area"
};
const _hoisted_3 = {
  key: 1,
  ref: "formAreaEl",
  class: "pagoda-form-table-layout__form-area"
};
const _hoisted_4 = {
  key: 2,
  class: "pagoda-form-table-layout__after-form-area"
};
const _hoisted_5 = {
  key: 3,
  class: "pagoda-form-table-layout__table-btns-area"
};
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createElementBlock(
    "div",
    _hoisted_1,
    [
      $setup.hasBeforeFormSlot ? (_openBlock(), _createElementBlock("div", _hoisted_2, [
        _renderSlot(_ctx.$slots, "before-form")
      ])) : _createCommentVNode("v-if", true),
      $setup.hasFormSlot ? (_openBlock(), _createElementBlock(
        "div",
        _hoisted_3,
        [
          _renderSlot(_ctx.$slots, "form", { btnsPosition: $setup.btnsPosition })
        ],
        512
        /* NEED_PATCH */
      )) : _createCommentVNode("v-if", true),
      $setup.hasAfterFormSlot ? (_openBlock(), _createElementBlock("div", _hoisted_4, [
        _renderSlot(_ctx.$slots, "after-form")
      ])) : _createCommentVNode("v-if", true),
      $setup.hasTableBtnsSlot ? (_openBlock(), _createElementBlock("div", _hoisted_5, [
        _renderSlot(_ctx.$slots, "table-btns")
      ])) : _createCommentVNode("v-if", true),
      $setup.hasTableSlot ? (_openBlock(), _createElementBlock(
        "div",
        {
          key: 4,
          style: _normalizeStyle({
            marginTop: `${$setup.tableAreaMarginTop}px`
          }),
          class: "pagoda-form-table-layout__table-area"
        },
        [
          _renderSlot(_ctx.$slots, "table")
        ],
        4
        /* STYLE */
      )) : _createCommentVNode("v-if", true)
    ],
    512
    /* NEED_PATCH */
  );
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
