var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { inputNumberProps } from "./inputNumber.mjs";
import { inputProps } from "element-plus/es/index.mjs";
import { ElInput } from "element-plus/es/index.mjs";
import { usePickProps } from "pagoda-shared";
import { isNumberExceptNaN, isNumberString } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("input-number");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: inputNumberProps,
  emits: ["update:modelValue"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const props = __props;
    const elInputAttrs = usePickProps(props, inputProps);
    const emit = __emit;
    function handleBeforeInput(val) {
      const newVal = [];
      const valStrArr = val.split("");
      let hasDot = false;
      valStrArr.forEach((str, idx) => {
        const preNumber = Number(valStrArr[idx - 1]);
        if (str === "-" && idx === 0 && !props.positiveNumber) {
          newVal.push(str);
        } else if (str === "." && isNumberExceptNaN(preNumber) && !hasDot && props.precision !== 0) {
          newVal.push(str);
          hasDot = true;
        } else if (!/[^\d]/.test(str) && valStrArr[idx - props.precision - 1] !== ".") {
          newVal.push(str);
        }
      });
      return newVal.join("");
    }
    function handleInput(val) {
      const result = handleBeforeInput(val);
      emit("update:modelValue", result.trim());
    }
    function handleBlur() {
      if (props.precision !== 0 && isNumberString(props.modelValue)) {
        emit(
          "update:modelValue",
          parseFloat(props.modelValue).toFixed(props.precision)
        );
      }
    }
    const __returned__ = { name, props, elInputAttrs, emit, handleBeforeInput, handleInput, handleBlur, get ElInput() {
      return ElInput;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { normalizeProps as _normalizeProps, guardReactiveProps as _guardReactiveProps, renderSlot as _renderSlot, mergeProps as _mergeProps, withCtx as _withCtx, renderList as _renderList, createSlots as _createSlots, openBlock as _openBlock, createBlock as _createBlock } from "vue";
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock(
    $setup["ElInput"],
    _mergeProps($setup.elInputAttrs, {
      ref: "elInputCtx",
      "onUpdate:modelValue": $setup.handleInput,
      onBlur: $setup.handleBlur
    }),
    _createSlots({
      _: 2
      /* DYNAMIC */
    }, [
      _renderList(_ctx.$slots, (_, slotName) => {
        return {
          name: slotName,
          fn: _withCtx((scope) => [
            _renderSlot(_ctx.$slots, slotName, _normalizeProps(_guardReactiveProps(scope)))
          ])
        };
      })
    ]),
    1040
    /* FULL_PROPS, DYNAMIC_SLOTS */
  );
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
