var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { ref, watch, inject } from "vue";
import { layoutV2HeaderProps } from "./layoutV2Header.mjs";
import { useRouter } from "vue-router";
import { useEffect } from "pagoda-shared";
import { LAYOUT_V2_INJECTION_KEY } from "../../layout-v2/src/types/index.mjs";
import { getMatchUrlCollection } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("layout-v2-header");
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, {
  name
}), {
  __name: "layout-v2-header",
  props: layoutV2HeaderProps,
  emits: ["select-header-menu"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const layoutV2Provider = inject(LAYOUT_V2_INJECTION_KEY);
    const router = useRouter();
    const props = __props;
    const emit = __emit;
    const activeMenu = ref();
    watch(router.currentRoute, setDefaultActive, {
      immediate: true
    });
    watch(() => props.menu, setDefaultActive);
    useEffect(
      () => {
        if (layoutV2Provider) {
          layoutV2Provider.hasHeader.value = true;
        }
      },
      () => {
        if (layoutV2Provider) {
          layoutV2Provider.hasHeader.value = false;
        }
      }
    );
    function setDefaultActive() {
      const fullPath = router.currentRoute.value.fullPath.split("?")[0];
      const mathUrlCollection = getMatchUrlCollection(fullPath);
      activeMenu.value = props.menu.find((menuItem) => {
        return mathUrlCollection.includes(menuItem.url);
      });
    }
    const __returned__ = { name, layoutV2Provider, router, props, emit, activeMenu, setDefaultActive };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { renderSlot as _renderSlot, createElementVNode as _createElementVNode, renderList as _renderList, Fragment as _Fragment, openBlock as _openBlock, createElementBlock as _createElementBlock, toDisplayString as _toDisplayString, normalizeClass as _normalizeClass, createCommentVNode as _createCommentVNode } from "vue";
const _hoisted_1 = { class: "pagoda-layout-v2-header" };
const _hoisted_2 = { class: "pagoda-layout-v2-header-title" };
const _hoisted_3 = {
  key: 0,
  class: "pagoda-layout-v2-header-menu"
};
const _hoisted_4 = ["onClick"];
const _hoisted_5 = { class: "pagoda-layout-v2-header-right" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createElementBlock("div", _hoisted_1, [
    _createElementVNode("div", _hoisted_2, [
      _renderSlot(_ctx.$slots, "header-left")
    ]),
    _ctx.menu.length ? (_openBlock(), _createElementBlock("div", _hoisted_3, [
      _renderSlot(_ctx.$slots, "before-menu"),
      _createElementVNode("ul", null, [
        (_openBlock(true), _createElementBlock(
          _Fragment,
          null,
          _renderList(_ctx.menu, (menuItem) => {
            return _openBlock(), _createElementBlock("li", {
              class: _normalizeClass({ active: $setup.activeMenu === menuItem }),
              onClick: ($event) => $setup.emit("select-header-menu", menuItem)
            }, _toDisplayString(menuItem.label), 11, _hoisted_4);
          }),
          256
          /* UNKEYED_FRAGMENT */
        ))
      ]),
      _renderSlot(_ctx.$slots, "after-menu")
    ])) : _createCommentVNode("v-if", true),
    _createElementVNode("div", _hoisted_5, [
      _renderSlot(_ctx.$slots, "header-right")
    ])
  ]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
