import { ref, computed } from "vue";
function useTabContextMenu({
  isTabClosable,
  customTabContextMenus,
  onCloseCurrentTab,
  onCloseOthersTabs,
  onCloseAllTabs
}) {
  const mouseRightDownTab = ref();
  const allTabContextMenus = computed(() => {
    const defaultContextMenus = [
      {
        title: "\u5173\u95ED",
        disabled: !mouseRightDownTab.value || !isTabClosable(mouseRightDownTab.value),
        divided: Boolean(customTabContextMenus.value.length),
        onClick: () => onCloseCurrentTab(mouseRightDownTab.value)
      },
      {
        title: "\u5173\u95ED\u5176\u4ED6",
        onClick: () => onCloseOthersTabs(mouseRightDownTab.value)
      },
      {
        title: "\u5173\u95ED\u6240\u6709",
        onClick: () => onCloseAllTabs(mouseRightDownTab.value)
      }
    ];
    return customTabContextMenus.value.concat(defaultContextMenus);
  });
  function contextmenuOnTab(tab) {
    mouseRightDownTab.value = tab;
  }
  return {
    allTabContextMenus,
    contextmenuOnTab
  };
}
export {
  useTabContextMenu
};
