import { defineComponent as _defineComponent } from "vue";
import { provide } from "vue";
import LayoutSubMenu from "./sub-menu.vue.mjs";
import { ElMenu } from "element-plus/es/index.mjs";
import mitt from "mitt";
import { GET_EMPTY_ARR } from "pagoda-shared";
import { LAYOUT_SIDE_MENU_INJECTION_KEY } from "./types/index.mjs";
const __vue_sfc__ = /* @__PURE__ */ _defineComponent({
  __name: "side-menu",
  props: {
    elMenuProps: { type: Object, required: true },
    menus: { type: Array, required: true, default: GET_EMPTY_ARR },
    titleKey: { type: String, required: false, default: "title" },
    childrenKey: { type: String, required: false, default: "children" },
    iconKey: { type: String, required: false, default: "icon" },
    indexKey: { type: String, required: false, default: "index" }
  },
  emits: ["select"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const emit = __emit;
    const sideMenuEmitter = mitt();
    provide(LAYOUT_SIDE_MENU_INJECTION_KEY, {
      sideMenuEmitter
    });
    sideMenuEmitter.on("pagoda-layout:side-menu-item-click", (item) => {
      if (item.disabled)
        return;
      emit("select", item);
    });
    const __returned__ = { emit, sideMenuEmitter, LayoutSubMenu, get ElMenu() {
      return ElMenu;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
import { renderList as _renderList, Fragment as _Fragment, openBlock as _openBlock, createElementBlock as _createElementBlock, createBlock as _createBlock, mergeProps as _mergeProps, withCtx as _withCtx } from "vue";
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock(
    $setup["ElMenu"],
    _mergeProps({ ref: "elMenuCtx" }, $props.elMenuProps),
    {
      default: _withCtx(() => [
        (_openBlock(true), _createElementBlock(
          _Fragment,
          null,
          _renderList($props.menus, (menu) => {
            return _openBlock(), _createBlock($setup["LayoutSubMenu"], {
              key: menu[$props.titleKey],
              menu,
              "title-key": $props.titleKey,
              "children-key": $props.childrenKey,
              "icon-key": $props.iconKey,
              "index-key": $props.indexKey
            }, null, 8, ["menu", "title-key", "children-key", "icon-key", "index-key"]);
          }),
          128
          /* KEYED_FRAGMENT */
        ))
      ]),
      _: 1
      /* STABLE */
    },
    16
    /* FULL_PROPS */
  );
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
