import { defineComponent as _defineComponent } from "vue";
import { computed, ref } from "vue";
import { ElDropdown, ElDropdownMenu, ElIcon } from "element-plus/es/index.mjs";
import { ArrowDown as ElIconArrowDown } from "@element-plus/icons-vue";
import { GET_EMPTY_ARR } from "pagoda-shared";
const __vue_sfc__ = /* @__PURE__ */ _defineComponent({
  __name: "user-info",
  props: {
    avatar: { type: String, required: false },
    userName: { type: String, required: false },
    info: { type: Array, required: false, default: GET_EMPTY_ARR },
    operate: { type: Array, required: false, default: GET_EMPTY_ARR },
    infoLabelWidth: { type: Number, required: false, default: 60 },
    onLogout: { type: Function, required: false },
    onOperateItemClick: { type: Function, required: false }
  },
  setup(__props, { expose: __expose }) {
    __expose();
    const props = __props;
    const elDropdownCtx = ref();
    const labelStyle = computed(() => {
      return {
        width: `${props.infoLabelWidth}px`
      };
    });
    function handleMenuClick(cb) {
      elDropdownCtx.value.handleClose();
      cb == null ? void 0 : cb();
    }
    const __returned__ = { props, elDropdownCtx, labelStyle, handleMenuClick, get ElDropdown() {
      return ElDropdown;
    }, get ElDropdownMenu() {
      return ElDropdownMenu;
    }, get ElIcon() {
      return ElIcon;
    }, get ElIconArrowDown() {
      return ElIconArrowDown;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
import { openBlock as _openBlock, createElementBlock as _createElementBlock, renderSlot as _renderSlot, toDisplayString as _toDisplayString, createTextVNode as _createTextVNode, createElementVNode as _createElementVNode, createVNode as _createVNode, withCtx as _withCtx, normalizeStyle as _normalizeStyle, renderList as _renderList, Fragment as _Fragment, createBlock as _createBlock } from "vue";
const _hoisted_1 = { class: "pagoda-layout__user-info" };
const _hoisted_2 = ["src"];
const _hoisted_3 = {
  key: 1,
  class: "pagoda-layout__avatar pd-icon-avatar"
};
const _hoisted_4 = { class: "pagoda-layout__user-name" };
const _hoisted_5 = { class: "content" };
const _hoisted_6 = { class: "user-info" };
const _hoisted_7 = { class: "info" };
const _hoisted_8 = { class: "info-item" };
const _hoisted_9 = ["src"];
const _hoisted_10 = {
  key: 1,
  class: "avatar pd-icon-avatar"
};
const _hoisted_11 = { class: "user-name" };
const _hoisted_12 = { class: "info-item__content" };
const _hoisted_13 = { class: "operate" };
const _hoisted_14 = ["onClick"];
const _hoisted_15 = { class: "logout" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock(
    $setup["ElDropdown"],
    {
      ref: "elDropdownCtx",
      placement: "bottom-end",
      trigger: "click",
      class: "pagoda-layout__user-info-wrapper"
    },
    {
      dropdown: _withCtx(() => [
        _createVNode(
          $setup["ElDropdownMenu"],
          {
            ref: "elDropdownMenuCtx",
            class: "pagoda-layout-user-info"
          },
          {
            default: _withCtx(() => [
              _createElementVNode("div", _hoisted_5, [
                _createElementVNode("div", _hoisted_6, [
                  _createElementVNode("div", _hoisted_7, [
                    _createElementVNode("div", _hoisted_8, [
                      _createElementVNode(
                        "label",
                        {
                          class: "info-item__label",
                          style: _normalizeStyle($setup.labelStyle)
                        },
                        [
                          $props.avatar ? (_openBlock(), _createElementBlock("img", {
                            key: 0,
                            class: "avatar",
                            src: $props.avatar
                          }, null, 8, _hoisted_9)) : (_openBlock(), _createElementBlock("i", _hoisted_10))
                        ],
                        4
                        /* STYLE */
                      ),
                      _createElementVNode("span", _hoisted_11, [
                        _renderSlot(_ctx.$slots, "user-name", { data: $props.userName }, () => [
                          _createTextVNode(
                            _toDisplayString($props.userName),
                            1
                            /* TEXT */
                          )
                        ])
                      ])
                    ]),
                    (_openBlock(true), _createElementBlock(
                      _Fragment,
                      null,
                      _renderList($props.info, (infoItem) => {
                        return _openBlock(), _createElementBlock("div", {
                          key: infoItem.name,
                          class: "info-item more-info"
                        }, [
                          _createElementVNode(
                            "label",
                            {
                              class: "info-item__label",
                              style: _normalizeStyle($setup.labelStyle)
                            },
                            _toDisplayString(infoItem.name) + "\uFF1A",
                            5
                            /* TEXT, STYLE */
                          ),
                          _createElementVNode("span", _hoisted_12, [
                            _renderSlot(_ctx.$slots, infoItem.slot, {
                              data: infoItem.content
                            }, () => [
                              _createTextVNode(
                                _toDisplayString(infoItem.content),
                                1
                                /* TEXT */
                              )
                            ])
                          ])
                        ]);
                      }),
                      128
                      /* KEYED_FRAGMENT */
                    ))
                  ])
                ]),
                _createElementVNode("div", _hoisted_13, [
                  (_openBlock(true), _createElementBlock(
                    _Fragment,
                    null,
                    _renderList($props.operate, (operateItem) => {
                      return _openBlock(), _createElementBlock("div", {
                        key: operateItem.name,
                        class: "operate-item"
                      }, [
                        _createElementVNode("span", {
                          onClick: ($event) => $setup.handleMenuClick(() => {
                            var _a;
                            return (_a = $props.onOperateItemClick) == null ? void 0 : _a.call($props, operateItem);
                          })
                        }, _toDisplayString(operateItem.name), 9, _hoisted_14)
                      ]);
                    }),
                    128
                    /* KEYED_FRAGMENT */
                  ))
                ])
              ]),
              _createElementVNode("div", _hoisted_15, [
                _createElementVNode("span", {
                  onClick: _cache[0] || (_cache[0] = ($event) => $setup.handleMenuClick($props.onLogout))
                }, "\u9000\u51FA\u767B\u5F55")
              ])
            ]),
            _: 3
            /* FORWARDED */
          },
          512
          /* NEED_PATCH */
        )
      ]),
      default: _withCtx(() => [
        _createElementVNode("div", _hoisted_1, [
          $props.avatar ? (_openBlock(), _createElementBlock("img", {
            key: 0,
            class: "pagoda-layout__avatar",
            src: $props.avatar
          }, null, 8, _hoisted_2)) : (_openBlock(), _createElementBlock("i", _hoisted_3)),
          _createElementVNode("span", _hoisted_4, [
            _renderSlot(_ctx.$slots, "user-name", { data: $props.userName }, () => [
              _createTextVNode(
                _toDisplayString($props.userName),
                1
                /* TEXT */
              )
            ])
          ]),
          _createVNode($setup["ElIcon"], { class: "arrow-down-icon" }, {
            default: _withCtx(() => [
              _createVNode($setup["ElIconArrowDown"])
            ]),
            _: 1
            /* STABLE */
          })
        ])
      ]),
      _: 3
      /* FORWARDED */
    },
    512
    /* NEED_PATCH */
  );
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
