var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { computed } from "vue";
import { numberRangeProps } from "./numberRange.mjs";
import { InputNumber } from "../../input-number/index.mjs";
import { Range } from "../../range/index.mjs";
import { isEmpty } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("number-range");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: numberRangeProps,
  emits: ["update:modelValue"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const props = __props;
    const emit = __emit;
    const clearableComputed = computed(() => {
      return (!isEmpty(rangeStartValue.value) || !isEmpty(rangeEndValue.value)) && props.clearable;
    });
    const rangeStartValue = computed(() => {
      return props.modelValue[0] || "";
    });
    const rangeEndValue = computed(() => {
      return props.modelValue[1] || "";
    });
    function handleRangeStartChange(val) {
      emit("update:modelValue", [val, rangeEndValue.value]);
    }
    function handleRangeEndChange(val) {
      emit("update:modelValue", [rangeStartValue.value, val]);
    }
    function handleClear() {
      emit("update:modelValue", []);
    }
    const __returned__ = { name, props, emit, clearableComputed, rangeStartValue, rangeEndValue, handleRangeStartChange, handleRangeEndChange, handleClear, get InputNumber() {
      return InputNumber;
    }, get Range() {
      return Range;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { createVNode as _createVNode, withCtx as _withCtx, openBlock as _openBlock, createBlock as _createBlock } from "vue";
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock($setup["Range"], {
    clearable: $setup.clearableComputed,
    "range-separator": _ctx.rangeSeparator,
    size: _ctx.size,
    onClear: $setup.handleClear
  }, {
    "range-start": _withCtx(({ focus, blur }) => [
      _createVNode($setup["InputNumber"], {
        size: _ctx.size,
        placeholder: _ctx.startPlaceholder,
        precision: _ctx.precision,
        "positive-number": _ctx.positiveNumber,
        "model-value": $setup.rangeStartValue,
        "onUpdate:modelValue": $setup.handleRangeStartChange,
        onFocus: focus,
        onBlur: blur
      }, null, 8, ["size", "placeholder", "precision", "positive-number", "model-value", "onFocus", "onBlur"])
    ]),
    "range-end": _withCtx(({ focus, blur }) => [
      _createVNode($setup["InputNumber"], {
        size: _ctx.size,
        placeholder: _ctx.endPlaceholder,
        precision: _ctx.precision,
        "positive-number": _ctx.positiveNumber,
        "model-value": $setup.rangeEndValue,
        "onUpdate:modelValue": $setup.handleRangeEndChange,
        onFocus: focus,
        onBlur: blur
      }, null, 8, ["size", "placeholder", "precision", "positive-number", "model-value", "onFocus", "onBlur"])
    ]),
    _: 1
    /* STABLE */
  }, 8, ["clearable", "range-separator", "size"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
