var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { ref, computed } from "vue";
import { resizeContainerProps } from "./resizeContainer.mjs";
import { addUnit } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("resize-container");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: resizeContainerProps,
  emits: ["drag-start", "draging", "drag-end"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const props = __props;
    const emit = __emit;
    const dragState = ref("drag-end");
    const size = ref(props.defaultSize || props.minSize);
    const resizeAreaEl = ref();
    const propMap = computed(() => {
      return {
        row: {
          offset: "offsetWidth",
          client: "clientX",
          cursor: "col-resize"
        },
        column: {
          offset: "offsetHeight",
          client: "clientY",
          cursor: "row-resize"
        }
      }[props.direction];
    });
    function handleDragBarMouseDown(e) {
      const startPoint = e[propMap.value.client];
      const resizeAreaSize = resizeAreaEl.value[propMap.value.offset];
      let changeSize;
      const originalCursor = getComputedStyle(document.documentElement).cursor;
      dragState.value = "drag-start";
      document.documentElement.style.cursor = propMap.value.cursor;
      emit("drag-start", size.value);
      document.onmousemove = (e2) => {
        e2.preventDefault();
        dragState.value = "draging";
        const curPoint = e2[propMap.value.client];
        let distPoint = Math.abs(curPoint - startPoint);
        if (props.reverse)
          distPoint = -distPoint;
        changeSize = Math.floor(
          curPoint > startPoint ? resizeAreaSize + distPoint : resizeAreaSize - distPoint
        );
        size.value = changeSize > props.minSize ? changeSize < props.maxSize ? changeSize : props.maxSize : props.minSize;
        emit("draging", size.value);
      };
      document.onmouseup = () => {
        dragState.value = "drag-end";
        document.documentElement.style.cursor = originalCursor === "auto" ? "" : originalCursor;
        document.onmousemove = null;
        emit("drag-end", size.value);
      };
    }
    const __returned__ = { name, props, emit, dragState, size, resizeAreaEl, propMap, handleDragBarMouseDown, get addUnit() {
      return addUnit;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { createElementVNode as _createElementVNode, renderSlot as _renderSlot, normalizeStyle as _normalizeStyle, normalizeClass as _normalizeClass, openBlock as _openBlock, createElementBlock as _createElementBlock } from "vue";
const _hoisted_1 = { class: "pagoda-resize-container__flex-area" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createElementBlock(
    "div",
    {
      class: _normalizeClass(["pagoda-resize-container", [`pagoda-resize-container--${$setup.dragState}`, `pagoda-resize-container--direction-${_ctx.direction}`, { "pagoda-resize-container--reverse": _ctx.reverse }]])
    },
    [
      _createElementVNode(
        "div",
        {
          ref: "resizeAreaEl",
          class: "pagoda-resize-container__resize-area",
          style: _normalizeStyle({ [_ctx.direction === "column" ? "height" : "width"]: $setup.addUnit($setup.size) })
        },
        [
          _createElementVNode(
            "span",
            {
              class: "pagoda-resize-container__drag-bar",
              onMousedown: $setup.handleDragBarMouseDown
            },
            null,
            32
            /* NEED_HYDRATION */
          ),
          _renderSlot(_ctx.$slots, "resize-area")
        ],
        4
        /* STYLE */
      ),
      _createElementVNode("div", _hoisted_1, [
        _renderSlot(_ctx.$slots, "flex-area")
      ])
    ],
    2
    /* CLASS */
  );
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
