import { buildProps, definePropType } from "element-plus/es/utils/index.mjs";
import { GET_EMPTY_ARR, GET_EMPTY_OBJ } from "pagoda-shared";
const selectTreeProps = buildProps({
  modelValue: {
    type: definePropType(
      [String, Number, Object, Array]
    ),
    required: true,
    default: ""
  },
  bindObject: {
    type: Boolean
  },
  multiple: {
    type: Boolean
  },
  filterable: {
    type: Boolean
  },
  collapseTags: {
    type: Boolean
  },
  clearable: {
    type: Boolean
  },
  lazy: {
    type: Boolean
  },
  load: {
    type: definePropType(Function)
  },
  checkStrictly: {
    type: Boolean
  },
  filterChildWhenSelectAll: {
    type: Boolean
  },
  placeholder: {
    type: String
  },
  label: {
    type: definePropType([
      String,
      Function
    ]),
    default: "label"
  },
  valueKey: {
    type: String,
    default: "value"
  },
  childrenKey: {
    type: String,
    default: "children"
  },
  disabled: {
    type: definePropType([
      String,
      Function
    ]),
    default: "disabled"
  },
  isLeaf: {
    type: definePropType([
      String,
      Function
    ]),
    default: "isLeaf"
  },
  data: {
    type: definePropType(Array),
    default: GET_EMPTY_ARR
  },
  treeProps: {
    type: definePropType(Object),
    default: GET_EMPTY_OBJ
  },
  selectProps: {
    type: definePropType(Object),
    default: GET_EMPTY_OBJ
  }
});
export {
  selectTreeProps
};
