import { useSelection } from '../composables/use-selection';
import type { Ref } from 'vue';
import type { Column } from 'element-plus/es/components/table-v2/src/types';
import type { DefaultRow } from 'element-plus/es/components/table/src/table/defaults';
export interface VirtualTableColumn<T = any> extends Column<T> {
    type?: 'selection' | 'index';
    selectable?: (row: DefaultRow, index: number) => boolean;
    label?: string;
    prop?: string;
    slot?: string;
}
export interface TableStore extends ReturnType<typeof useSelection> {
    tableData: Ref<DefaultRow[]>;
}
