import type { TablePaginationProps, TableRequestHandler } from '../../table';
import type { VirtualTableColumn } from './types';
import type { ExtractPropTypes } from 'vue';
import type { Sort } from 'element-plus/es/components/table/src/table/defaults';
export declare const virtualTableProps: {
    wrapperHeight: {
        readonly type: import("vue").PropType<import("element-plus/es/utils").EpPropMergeType<(StringConstructor | NumberConstructor)[], unknown, unknown>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    emptyText: {
        readonly type: import("vue").PropType<string>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    request: {
        readonly type: import("vue").PropType<TableRequestHandler>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    onRequest: {
        readonly type: import("vue").PropType<(currentPage: number, pageSize: number, sortable?: Sort | null) => void>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    columns: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => VirtualTableColumn<any>[]) | (() => VirtualTableColumn<any>[]) | (((new (...args: any[]) => VirtualTableColumn<any>[]) | (() => VirtualTableColumn<any>[])) | null)[], unknown, unknown, () => never[], boolean>;
    autoRequest: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, boolean, boolean>;
    pagination: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => TablePaginationProps) | (() => TablePaginationProps) | (((new (...args: any[]) => TablePaginationProps) | (() => TablePaginationProps)) | null)[], unknown, unknown, () => {}, boolean>;
    data: {
        type: import("vue").PropType<unknown>;
    };
    height: {
        type: import("vue").PropType<unknown>;
    };
    class: StringConstructor;
    style: {
        readonly type: import("vue").PropType<import("vue").CSSProperties>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    onScroll: {
        readonly type: import("vue").PropType<(...args: any[]) => void>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    fixed: BooleanConstructor;
    maxHeight: NumberConstructor;
    headerClass: {
        readonly type: import("vue").PropType<import("element-plus/es/utils").EpPropMergeType<(new (...args: any[]) => string | import("element-plus").HeaderClassNameGetter<any>) | (() => string | import("element-plus").HeaderClassNameGetter<any>) | ((new (...args: any[]) => string | import("element-plus").HeaderClassNameGetter<any>) | (() => string | import("element-plus").HeaderClassNameGetter<any>))[], unknown, unknown>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    sortBy: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => import("element-plus").SortBy) | (() => import("element-plus").SortBy) | ((new (...args: any[]) => import("element-plus").SortBy) | (() => import("element-plus").SortBy))[], unknown, unknown, () => {
        key: import("element-plus/es/components/table-v2/src/types").KeyType;
        order: import("element-plus").TableV2SortOrder;
    }, boolean>;
    rowKey: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => string | number | symbol) | (() => import("element-plus/es/components/table-v2/src/types").KeyType) | ((new (...args: any[]) => string | number | symbol) | (() => import("element-plus/es/components/table-v2/src/types").KeyType))[], unknown, unknown, "id", boolean>;
    scrollbarAlwaysOn: BooleanConstructor;
    cache: import("element-plus/es/utils").EpPropFinalized<NumberConstructor, never, never, 2, false>;
    estimatedRowHeight: {
        readonly default: undefined;
        readonly type: import("vue").PropType<number>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        readonly __epPropKey: true;
    };
    headerProps: {
        readonly type: import("vue").PropType<any>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    headerCellProps: {
        readonly type: import("vue").PropType<any>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    headerHeight: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => number | number[]) | (() => number | number[]) | ((new (...args: any[]) => number | number[]) | (() => number | number[]))[], unknown, unknown, 50, boolean>;
    footerHeight: import("element-plus/es/utils").EpPropFinalized<NumberConstructor, unknown, unknown, 0, boolean>;
    rowClass: {
        readonly type: import("vue").PropType<import("element-plus/es/utils").EpPropMergeType<(new (...args: any[]) => string | import("element-plus").RowClassNameGetter<any>) | (() => string | import("element-plus").RowClassNameGetter<any>) | ((new (...args: any[]) => string | import("element-plus").RowClassNameGetter<any>) | (() => string | import("element-plus").RowClassNameGetter<any>))[], unknown, unknown>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    rowProps: {
        readonly type: import("vue").PropType<any>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    rowHeight: import("element-plus/es/utils").EpPropFinalized<NumberConstructor, unknown, unknown, 50, boolean>;
    cellProps: {
        readonly type: import("vue").PropType<import("element-plus/es/utils").EpPropMergeType<(new (...args: any[]) => Record<string, any> | import("element-plus").ExtraCellPropGetter<any>) | (() => Record<string, any> | import("element-plus").ExtraCellPropGetter<any>) | ((new (...args: any[]) => Record<string, any> | import("element-plus").ExtraCellPropGetter<any>) | (() => Record<string, any> | import("element-plus").ExtraCellPropGetter<any>))[], unknown, unknown>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    dataGetter: {
        readonly type: import("vue").PropType<import("element-plus/es/components/table-v2/src/types").DataGetter<any>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    fixedData: {
        readonly type: import("vue").PropType<any[]>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    expandColumnKey: StringConstructor;
    expandedRowKeys: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => import("element-plus/es/components/table-v2/src/types").KeyType[]) | (() => import("element-plus/es/components/table-v2/src/types").KeyType[]) | ((new (...args: any[]) => import("element-plus/es/components/table-v2/src/types").KeyType[]) | (() => import("element-plus/es/components/table-v2/src/types").KeyType[]))[], unknown, unknown, () => never[], boolean>;
    defaultExpandedRowKeys: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => import("element-plus/es/components/table-v2/src/types").KeyType[]) | (() => import("element-plus/es/components/table-v2/src/types").KeyType[]) | ((new (...args: any[]) => import("element-plus/es/components/table-v2/src/types").KeyType[]) | (() => import("element-plus/es/components/table-v2/src/types").KeyType[]))[], unknown, unknown, () => never[], boolean>;
    useIsScrolling: BooleanConstructor;
    indentSize: import("element-plus/es/utils").EpPropFinalized<NumberConstructor, unknown, unknown, 12, boolean>;
    iconSize: import("element-plus/es/utils").EpPropFinalized<NumberConstructor, unknown, unknown, 12, boolean>;
    hScrollbarSize: import("element-plus/es/utils").EpPropFinalized<NumberConstructor, unknown, unknown, 6, boolean>;
    vScrollbarSize: import("element-plus/es/utils").EpPropFinalized<NumberConstructor, unknown, unknown, 6, boolean>;
    sortState: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => import("element-plus").SortState) | (() => import("element-plus").SortState) | ((new (...args: any[]) => import("element-plus").SortState) | (() => import("element-plus").SortState))[], unknown, unknown, undefined, boolean>;
    onColumnSort: {
        readonly type: import("vue").PropType<import("element-plus").ColumnSortHandler<any>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    onExpandedRowsChange: {
        readonly type: import("vue").PropType<import("element-plus").ExpandedRowsChangeHandler>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    onEndReached: {
        readonly type: import("vue").PropType<(distance: number) => void>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    onRowExpand: {
        readonly type: import("vue").PropType<import("element-plus").RowExpandHandler>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    onRowsRendered: {
        readonly type: import("vue").PropType<(params: import("element-plus/es/components/table-v2/src/grid").onRowRenderedParams) => void>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    rowEventHandlers: {
        readonly type: import("vue").PropType<import("element-plus").RowEventHandlers>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
};
export type VirtualTableProps = ExtractPropTypes<typeof virtualTableProps>;
