var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_vue2 = require("vue");
var import_dateRange = require("./dateRange");
var import_lib = require("element-plus/lib/index.js");
var import_range = require("../../range");
var import_dayjs = __toESM(require("dayjs"));
var import_utils = require("../../utils/index");
var import_vue3 = require("vue");
const name = (0, import_utils.createNamespace)("date-range");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ (0, import_vue.defineComponent)(__spreadProps(__spreadValues({}, __default__), {
  props: import_dateRange.dateRangeProps,
  emits: ["update:modelValue"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const props = __props;
    const emit = __emit;
    const showClearable = (0, import_vue2.computed)(() => {
      return props.clearable && Boolean(startTime.value || endTime.value);
    });
    const valueFormatComputed = (0, import_vue2.computed)(() => {
      return props.valueFormat || {
        month: "YYYY-MM",
        year: "YYYY",
        date: "YYYY-MM-DD"
      }[props.type];
    });
    const startTime = (0, import_vue2.computed)(() => {
      return props.modelValue[0];
    });
    const endTime = (0, import_vue2.computed)(() => {
      return props.modelValue[1];
    });
    const startPickerAttrs = (0, import_vue2.computed)(() => {
      return getPickerProps("start", props.startPickerProps);
    });
    const endPickerAttrs = (0, import_vue2.computed)(() => {
      return getPickerProps("end", props.endPickerProps);
    });
    const startPlaceholder = (0, import_vue2.computed)(() => {
      return getPickerPlaceholder("start");
    });
    const endPlaceholder = (0, import_vue2.computed)(() => {
      return getPickerPlaceholder("end");
    });
    function getPickerProps(pickerType, pickerProps) {
      return Object.assign({}, pickerProps, {
        type: props.type,
        clearable: false,
        modelValue: pickerType === "start" ? startTime.value : endTime.value,
        placeholder: pickerType === "start" ? startPlaceholder.value : endPlaceholder.value,
        disabledDate: getDisabledDate(pickerType)
      });
    }
    function getPickerPlaceholder(pickerType) {
      const prefix = {
        start: "\u5F00\u59CB",
        end: "\u7ED3\u675F"
      }[pickerType];
      const text = {
        month: "\u6708\u4EFD",
        date: "\u5E74\u4EFD",
        year: "\u65E5\u671F"
      }[props.type];
      return `${prefix}${text}`;
    }
    function getDisabledDate(pickerType) {
      const isStartPicker = pickerType === "start";
      const pickerProps = isStartPicker ? props.startPickerProps : props.endPickerProps;
      return (pickerTime) => {
        const isDisabledDate = pickerProps && pickerProps.disabledDate ? pickerProps.disabledDate(pickerTime) : false;
        const time = isStartPicker ? endTime.value : startTime.value;
        if (!time)
          return isDisabledDate;
        const _pickerTime = (0, import_dayjs.default)(pickerTime).valueOf();
        const _time = (0, import_dayjs.default)(time).valueOf();
        return (isStartPicker ? _pickerTime > _time : _pickerTime < _time) || isDisabledDate;
      };
    }
    function handleClear() {
      emit("update:modelValue", []);
    }
    function handleUpdateStartValue(startTime2) {
      emit("update:modelValue", [startTime2, endTime.value]);
    }
    function handleUpdateEndValue(endTime2) {
      emit("update:modelValue", [startTime.value, endTime2]);
    }
    const __returned__ = { name, props, emit, showClearable, valueFormatComputed, startTime, endTime, startPickerAttrs, endPickerAttrs, startPlaceholder, endPlaceholder, getPickerProps, getPickerPlaceholder, getDisabledDate, handleClear, handleUpdateStartValue, handleUpdateEndValue, get ElDatePicker() {
      return import_lib.ElDatePicker;
    }, get Range() {
      return import_range.Range;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return (0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["Range"], {
    class: "pagoda-date-range",
    "range-separator": _ctx.rangeSeparator,
    clearable: $setup.showClearable,
    onClear: $setup.handleClear
  }, {
    "range-start": (0, import_vue3.withCtx)(({ focus, blur }) => [
      (0, import_vue3.createVNode)($setup["ElDatePicker"], (0, import_vue3.mergeProps)({ "value-format": $setup.valueFormatComputed }, $setup.startPickerAttrs, {
        "onUpdate:modelValue": $setup.handleUpdateStartValue,
        onFocus: focus,
        onBlur: blur
      }), null, 16, ["value-format", "onFocus", "onBlur"])
    ]),
    "range-end": (0, import_vue3.withCtx)(({ focus, blur }) => [
      (0, import_vue3.createVNode)($setup["ElDatePicker"], (0, import_vue3.mergeProps)({ "value-format": $setup.valueFormatComputed }, $setup.endPickerAttrs, {
        "onUpdate:modelValue": $setup.handleUpdateEndValue,
        onFocus: focus,
        onBlur: blur
      }), null, 16, ["value-format", "onFocus", "onBlur"])
    ]),
    _: 1
    /* STABLE */
  }, 8, ["range-separator", "clearable"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
