import type { DirectiveArguments, ComponentPublicInstance } from 'vue';
import type { FormItemRule } from 'element-plus';
export interface FormFieldItem {
    hidden?: boolean;
    prop?: string;
    label?: string;
    type: FormFieldItemType;
    props?: Record<string, any>;
    readonly?: boolean;
    events?: Record<string, any>;
    directives?: DirectiveArguments;
    rules?: FormItemRule | FormItemRule[];
    textFormatter?(value: any): any;
    colProps?: Record<string, any>;
    slot?: string;
    config?: {
        labelKey?: string;
        valueKey?: string;
        disabledKey?: string;
        bindObject?: boolean;
        options?: Record<string, any>[];
        group?: boolean;
        trim?: boolean;
    };
    ref?: (ref: Element | ComponentPublicInstance | null) => void;
}
export type FormFieldItemType = 'text' | 'slot' | 'el-cascader' | 'el-date-picker' | 'el-input-number' | 'el-time-picker' | 'el-time-select' | 'el-switch' | 'el-autocomplete' | 'el-input' | 'el-select' | 'el-checkbox-group' | 'el-radio-group';
export type ComponentsConfig = {
    [key in FormFieldItemType]?: ComponentConfig;
};
export interface ComponentConfig {
    component: any;
    defaultProps?(field: FormFieldItem, config: {
        labelKey: string;
        valueKey: string;
        disabledKey: string;
    } & FormFieldItem['config']): Record<string, any>;
    defaultConfig?(field: FormFieldItem): FormFieldItem['config'];
    defaultValue?(props: Record<string, any>): any;
}
