var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_vue2 = require("vue");
var import_layoutV2 = require("./layoutV2");
var import_lib = require("element-plus/lib/index.js");
var import_icon = require("../../icon");
var import_directives = require("element-plus/lib/directives/index.js");
var import_types = require("./types");
var import_vue_router = require("vue-router");
var import_pagoda_shared = require("pagoda-shared");
var import_utils = require("../../utils");
var import_vue3 = require("vue");
const name = (0, import_utils.createNamespace)("layout-v2");
const __vue_sfc__ = /* @__PURE__ */ (0, import_vue.defineComponent)(__spreadProps(__spreadValues({}, {
  name
}), {
  __name: "layout-v2",
  props: import_layoutV2.layoutV2Props,
  emits: ["select-top-menu", "select-bottom-menu", "logo-click", "select-personal-setting-menu"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const props = __props;
    const emit = __emit;
    const router = (0, import_vue_router.useRouter)();
    const route = (0, import_vue_router.useRoute)();
    const hasHeader = (0, import_vue2.ref)(false);
    const personalSettingMenuVisible = (0, import_vue2.ref)(false);
    const userHeadTooltipVisible = (0, import_vue2.ref)(false);
    const subMenuActive = (0, import_vue2.ref)(false);
    const subMenu = (0, import_vue2.ref)();
    const activeSubMenu = (0, import_vue2.ref)(null);
    const activeTopMenu = (0, import_vue2.ref)(null);
    const activeBottomMenu = (0, import_vue2.ref)(null);
    if (router) {
      (0, import_vue2.watch)(router.currentRoute, setDefaultActive, {
        immediate: true
      });
      (0, import_vue2.watch)(() => [props.topMenu, props.bottomMenu], setDefaultActive);
    }
    function setDefaultActive() {
      const fullPath = route.fullPath.split("?")[0];
      const mathUrlCollection = (0, import_pagoda_shared.getMatchUrlCollection)(fullPath);
      activeBottomMenu.value = null;
      activeTopMenu.value = null;
      activeSubMenu.value = null;
      for (let i = 0; i < props.bottomMenu.length; i++) {
        const bottomMenuItem = props.bottomMenu[i];
        if (mathUrlCollection.includes(bottomMenuItem.url)) {
          activeBottomMenu.value = bottomMenuItem;
          return;
        }
      }
      for (let i = 0; i < props.topMenu.length; i++) {
        const topMenuItem = props.topMenu[i];
        if (!topMenuItem.subMenu && mathUrlCollection.includes(topMenuItem.url)) {
          activeTopMenu.value = topMenuItem;
          return;
        }
        if (topMenuItem.subMenu && topMenuItem.subMenu.data && topMenuItem.subMenu.data.length) {
          for (let i2 = 0; i2 < topMenuItem.subMenu.data.length; i2++) {
            const subMenuItem = topMenuItem.subMenu.data[i2];
            if (mathUrlCollection.includes(subMenuItem.url)) {
              activeTopMenu.value = topMenuItem;
              activeSubMenu.value = subMenuItem;
              return;
            }
          }
        }
      }
    }
    function handlePersonalMenuToogleVisible(e) {
      const target = e.target;
      userHeadTooltipVisible.value = false;
      if (target.tagName === "I" || target.tagName === "IMG" || target.className === "user" || target.className === "el-tooltip") {
        e.stopPropagation();
      }
      personalSettingMenuVisible.value = !personalSettingMenuVisible.value;
    }
    function hidePersonalSettingMenu() {
      personalSettingMenuVisible.value = false;
    }
    let hideMenuTimer;
    function handleHideMenu() {
      hideMenuTimer = window.setTimeout(() => {
        subMenuActive.value = false;
      }, 200);
    }
    function handleShowMenu() {
      clearTimeout(hideMenuTimer);
      subMenuActive.value = true;
    }
    function handleMenuMouseenter(e, menuItem) {
      if (menuItem.subMenu && menuItem.subMenu.data.length) {
        e.stopPropagation();
        handleShowMenu();
        subMenu.value = __spreadProps(__spreadValues({}, menuItem.subMenu), {
          title: menuItem.subMenu.title || menuItem.label,
          data: menuItem.subMenu.data.map((subMenu2) => {
            subMenu2._parent = menuItem;
            return subMenu2;
          })
        });
      }
    }
    (0, import_vue2.provide)(import_types.LAYOUT_V2_INJECTION_KEY, {
      hasHeader
    });
    const __returned__ = { name, props, emit, router, route, hasHeader, personalSettingMenuVisible, userHeadTooltipVisible, subMenuActive, subMenu, activeSubMenu, activeTopMenu, activeBottomMenu, setDefaultActive, handlePersonalMenuToogleVisible, hidePersonalSettingMenu, get hideMenuTimer() {
      return hideMenuTimer;
    }, set hideMenuTimer(v) {
      hideMenuTimer = v;
    }, handleHideMenu, handleShowMenu, handleMenuMouseenter, get ElTooltip() {
      return import_lib.ElTooltip;
    }, get Icon() {
      return import_icon.Icon;
    }, get vClickOutside() {
      return import_directives.ClickOutside;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
const _hoisted_1 = { class: "pagoda-layout-v2" };
const _hoisted_2 = { class: "pagoda-layout-v2__submenu-subtitle" };
const _hoisted_3 = ["onClick"];
const _hoisted_4 = ["src"];
const _hoisted_5 = { class: "submenu-label" };
const _hoisted_6 = { class: "pagoda-layout-v2__left-menu" };
const _hoisted_7 = { class: "top-area" };
const _hoisted_8 = ["src"];
const _hoisted_9 = { class: "menu-list" };
const _hoisted_10 = ["onMouseenter", "onClick"];
const _hoisted_11 = { class: "menu-item__label" };
const _hoisted_12 = { class: "bottom-area" };
const _hoisted_13 = { class: "menu-list" };
const _hoisted_14 = ["onClick"];
const _hoisted_15 = ["src"];
const _hoisted_16 = ["src"];
const _hoisted_17 = ["onClick"];
const _hoisted_18 = { class: "personal-setting-menu__label" };
const _hoisted_19 = { class: "pagoda-layout-v2__content" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return (0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)("div", _hoisted_1, [
    $setup.subMenu ? ((0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)(
      "div",
      {
        key: 0,
        class: (0, import_vue3.normalizeClass)(["pagoda-layout-v2__submenu", { active: $setup.subMenuActive }]),
        onMouseleave: $setup.handleHideMenu,
        onMouseenter: $setup.handleShowMenu
      },
      [
        (0, import_vue3.createCommentVNode)('<div class="pagoda-layout-v2__submenu-title">{{subMenu.title}}</div>'),
        (0, import_vue3.createElementVNode)("div", _hoisted_2, [
          _cache[5] || (_cache[5] = (0, import_vue3.createElementVNode)(
            "i",
            { class: "dot" },
            null,
            -1
            /* HOISTED */
          )),
          (0, import_vue3.createElementVNode)(
            "span",
            null,
            (0, import_vue3.toDisplayString)($setup.subMenu.title),
            1
            /* TEXT */
          )
        ]),
        (0, import_vue3.createElementVNode)("ul", {
          class: "pagoda-layout-v2__submenu-list",
          onClick: _cache[0] || (_cache[0] = ($event) => $setup.subMenuActive = false)
        }, [
          ((0, import_vue3.openBlock)(true), (0, import_vue3.createElementBlock)(
            import_vue3.Fragment,
            null,
            (0, import_vue3.renderList)($setup.subMenu.data, (subMenuItem) => {
              return (0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)("li", {
                key: subMenuItem.label,
                class: (0, import_vue3.normalizeClass)({ active: $setup.activeSubMenu === subMenuItem }),
                onClick: ($event) => $setup.emit("select-top-menu", subMenuItem)
              }, [
                subMenuItem.icon ? ((0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["Icon"], {
                  key: 0,
                  class: "submenu-icon",
                  is: subMenuItem.icon
                }, null, 8, ["is"])) : subMenuItem.img ? ((0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)("img", {
                  key: 1,
                  src: subMenuItem.img,
                  class: "submenu-img"
                }, null, 8, _hoisted_4)) : (0, import_vue3.createCommentVNode)("v-if", true),
                (0, import_vue3.createElementVNode)(
                  "span",
                  _hoisted_5,
                  (0, import_vue3.toDisplayString)(subMenuItem.label),
                  1
                  /* TEXT */
                )
              ], 10, _hoisted_3);
            }),
            128
            /* KEYED_FRAGMENT */
          ))
        ]),
        (0, import_vue3.renderSlot)(_ctx.$slots, `${$setup.subMenu.key}-after-menu`)
      ],
      34
      /* CLASS, NEED_HYDRATION */
    )) : (0, import_vue3.createCommentVNode)("v-if", true),
    (0, import_vue3.createElementVNode)("div", _hoisted_6, [
      (0, import_vue3.createElementVNode)("div", _hoisted_7, [
        (0, import_vue3.createElementVNode)("div", {
          class: "logo",
          onClick: _cache[1] || (_cache[1] = ($event) => $setup.emit("logo-click"))
        }, [
          _ctx.logoImg ? ((0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)("img", {
            key: 0,
            src: _ctx.logoImg
          }, null, 8, _hoisted_8)) : ((0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["Icon"], {
            key: 1,
            is: _ctx.logo
          }, null, 8, ["is"]))
        ]),
        (0, import_vue3.renderSlot)(_ctx.$slots, "before-top-menu"),
        (0, import_vue3.createElementVNode)("ul", _hoisted_9, [
          ((0, import_vue3.openBlock)(true), (0, import_vue3.createElementBlock)(
            import_vue3.Fragment,
            null,
            (0, import_vue3.renderList)(_ctx.topMenu, (menuItem) => {
              return (0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)("li", {
                key: menuItem.label,
                class: (0, import_vue3.normalizeClass)(["menu-item", { active: $setup.activeTopMenu === menuItem }]),
                onMouseenter: ($event) => $setup.handleMenuMouseenter($event, menuItem),
                onMouseleave: $setup.handleHideMenu,
                onClick: ($event) => !menuItem.subMenu && $setup.emit("select-top-menu", menuItem)
              }, [
                menuItem.icon ? ((0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["Icon"], {
                  key: 0,
                  class: "menu-item__icon",
                  is: menuItem.icon
                }, null, 8, ["is"])) : (0, import_vue3.createCommentVNode)("v-if", true),
                (0, import_vue3.createElementVNode)(
                  "div",
                  _hoisted_11,
                  (0, import_vue3.toDisplayString)(menuItem.label),
                  1
                  /* TEXT */
                )
              ], 42, _hoisted_10);
            }),
            128
            /* KEYED_FRAGMENT */
          ))
        ]),
        (0, import_vue3.renderSlot)(_ctx.$slots, "after-top-menu")
      ]),
      (0, import_vue3.createElementVNode)("div", _hoisted_12, [
        (0, import_vue3.renderSlot)(_ctx.$slots, "before-bottom-menu"),
        (0, import_vue3.createElementVNode)("ul", _hoisted_13, [
          ((0, import_vue3.openBlock)(true), (0, import_vue3.createElementBlock)(
            import_vue3.Fragment,
            null,
            (0, import_vue3.renderList)(_ctx.bottomMenu, (menuItem) => {
              return (0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["ElTooltip"], {
                key: menuItem.icon,
                effect: "light",
                content: menuItem.label,
                placement: "right"
              }, {
                default: (0, import_vue3.withCtx)(() => [
                  (0, import_vue3.createElementVNode)("li", {
                    class: (0, import_vue3.normalizeClass)(["menu-item", { active: $setup.activeBottomMenu === menuItem }]),
                    onClick: ($event) => $setup.emit("select-bottom-menu", menuItem)
                  }, [
                    menuItem.icon ? ((0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["Icon"], {
                      key: 0,
                      class: "menu-item__icon",
                      is: menuItem.icon
                    }, null, 8, ["is"])) : (0, import_vue3.createCommentVNode)("v-if", true)
                  ], 10, _hoisted_14)
                ]),
                _: 2
                /* DYNAMIC */
              }, 1032, ["content"]);
            }),
            128
            /* KEYED_FRAGMENT */
          ))
        ]),
        (0, import_vue3.renderSlot)(_ctx.$slots, "after-bottom-menu"),
        (0, import_vue3.createElementVNode)("div", {
          class: "user",
          onClick: $setup.handlePersonalMenuToogleVisible
        }, [
          _ctx.userHead.tooltip ? ((0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["ElTooltip"], {
            key: 0,
            visible: $setup.userHeadTooltipVisible,
            "onUpdate:visible": _cache[4] || (_cache[4] = ($event) => $setup.userHeadTooltipVisible = $event),
            effect: "light",
            content: _ctx.userHead.tooltip,
            placement: "right",
            manual: ""
          }, {
            default: (0, import_vue3.withCtx)(() => [
              (0, import_vue3.createElementVNode)(
                "div",
                {
                  onMouseenter: _cache[2] || (_cache[2] = ($event) => !$setup.personalSettingMenuVisible && ($setup.userHeadTooltipVisible = true)),
                  onMouseleave: _cache[3] || (_cache[3] = ($event) => $setup.userHeadTooltipVisible = false)
                },
                [
                  _ctx.userHead.src ? ((0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)("img", {
                    key: 0,
                    class: "user-head",
                    src: _ctx.userHead.src
                  }, null, 8, _hoisted_15)) : ((0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["Icon"], {
                    key: 1,
                    class: "user-head",
                    is: "pd-icon-avatar"
                  }))
                ],
                32
                /* NEED_HYDRATION */
              )
            ]),
            _: 1
            /* STABLE */
          }, 8, ["visible", "content"])) : ((0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)(
            import_vue3.Fragment,
            { key: 1 },
            [
              _ctx.userHead.src ? ((0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)("img", {
                key: 0,
                class: "user-head",
                src: _ctx.userHead.src
              }, null, 8, _hoisted_16)) : ((0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["Icon"], {
                key: 1,
                class: "user-head",
                is: "pd-icon-avatar"
              }))
            ],
            64
            /* STABLE_FRAGMENT */
          )),
          _ctx.personalSettingMenu.length ? (0, import_vue3.withDirectives)(((0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)(
            "div",
            {
              key: 2,
              class: "personal-setting-menu",
              style: (0, import_vue3.normalizeStyle)({ bottom: _ctx.personalSettingMenu.length === 1 ? "24px" : "0" })
            },
            [
              (0, import_vue3.createElementVNode)(
                "div",
                {
                  class: "personal-setting-menu__triangle",
                  style: (0, import_vue3.normalizeStyle)({
                    bottom: _ctx.personalSettingMenu.length === 1 ? "50%" : "36px",
                    transform: _ctx.personalSettingMenu.length === 1 ? "translateY(50%)" : "none"
                  })
                },
                null,
                4
                /* STYLE */
              ),
              ((0, import_vue3.openBlock)(true), (0, import_vue3.createElementBlock)(
                import_vue3.Fragment,
                null,
                (0, import_vue3.renderList)(_ctx.personalSettingMenu, (menuItem) => {
                  return (0, import_vue3.withDirectives)(((0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)("div", {
                    key: menuItem.label,
                    class: "personal-setting-menu__item",
                    onClick: ($event) => $setup.emit("select-personal-setting-menu", menuItem)
                  }, [
                    menuItem.icon ? ((0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["Icon"], {
                      key: 0,
                      class: "personal-setting-menu__icon",
                      is: menuItem.icon
                    }, null, 8, ["is"])) : (0, import_vue3.createCommentVNode)("v-if", true),
                    (0, import_vue3.createElementVNode)(
                      "span",
                      _hoisted_18,
                      (0, import_vue3.toDisplayString)(menuItem.label),
                      1
                      /* TEXT */
                    )
                  ], 8, _hoisted_17)), [
                    [$setup["vClickOutside"], $setup.hidePersonalSettingMenu]
                  ]);
                }),
                128
                /* KEYED_FRAGMENT */
              ))
            ],
            4
            /* STYLE */
          )), [
            [import_vue3.vShow, $setup.personalSettingMenuVisible]
          ]) : (0, import_vue3.createCommentVNode)("v-if", true)
        ])
      ])
    ]),
    (0, import_vue3.createElementVNode)(
      "div",
      {
        class: (0, import_vue3.normalizeClass)(["pagoda-layout-v2__main", { "has-header": $setup.hasHeader }])
      },
      [
        (0, import_vue3.createElementVNode)("div", _hoisted_19, [
          (0, import_vue3.renderSlot)(_ctx.$slots, "default")
        ])
      ],
      2
      /* CLASS */
    )
  ]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
