import type { ExtractPropTypes } from 'vue';
import type { MenuProps } from 'element-plus';
import type { LayoutMenuItem, LayoutTabItem, LayoutTabContextMenuItem, LayoutUserInfo as LayoutUserInfoT, LayoutUserInfoOnLogout, LayoutUserInfoOnOperateItemClick } from './types';
export declare const layoutProps: {
    logo: StringConstructor;
    logoText: StringConstructor;
    userInfo: {
        readonly type: import("vue").PropType<LayoutUserInfoT>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    onLogout: {
        readonly type: import("vue").PropType<LayoutUserInfoOnLogout>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    onOperateItemClick: {
        readonly type: import("vue").PropType<LayoutUserInfoOnOperateItemClick>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    defaultTabs: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => LayoutTabItem[]) | (() => LayoutTabItem[]) | (((new (...args: any[]) => LayoutTabItem[]) | (() => LayoutTabItem[])) | null)[], unknown, unknown, () => never[], boolean>;
    sideElMenuProps: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => Partial<MenuProps>) | (() => Partial<MenuProps>) | (((new (...args: any[]) => Partial<MenuProps>) | (() => Partial<MenuProps>)) | null)[], unknown, unknown, () => {}, boolean>;
    topElMenuProps: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => Partial<MenuProps>) | (() => Partial<MenuProps>) | (((new (...args: any[]) => Partial<MenuProps>) | (() => Partial<MenuProps>)) | null)[], unknown, unknown, () => {}, boolean>;
    sideMenus: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => LayoutMenuItem[]) | (() => LayoutMenuItem[]) | (((new (...args: any[]) => LayoutMenuItem[]) | (() => LayoutMenuItem[])) | null)[], unknown, unknown, () => never[], boolean>;
    topMenus: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => LayoutMenuItem[]) | (() => LayoutMenuItem[]) | (((new (...args: any[]) => LayoutMenuItem[]) | (() => LayoutMenuItem[])) | null)[], unknown, unknown, () => never[], boolean>;
    activeTab: {
        readonly type: import("vue").PropType<LayoutTabItem>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    fullscreen: BooleanConstructor;
    themeToggler: BooleanConstructor;
    tabContextMenus: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => LayoutTabContextMenuItem[]) | (() => LayoutTabContextMenuItem[]) | (((new (...args: any[]) => LayoutTabContextMenuItem[]) | (() => LayoutTabContextMenuItem[])) | null)[], unknown, unknown, () => never[], boolean>;
    beforeTabsRemove: {
        readonly type: import("vue").PropType<import("element-plus/es/utils").EpPropMergeType<(new (...args: any[]) => (removeTabsConfig: LayoutTabItem[], next: () => void, safeClose?: boolean) => void) | (() => ((removeTabsConfig: LayoutTabItem[], next: () => void, safeClose?: boolean) => void) | undefined) | {
            (): ((removeTabsConfig: LayoutTabItem[], next: () => void, safeClose?: boolean) => void) | undefined;
            new (): any;
            readonly prototype: any;
        } | (((new (...args: any[]) => (removeTabsConfig: LayoutTabItem[], next: () => void, safeClose?: boolean) => void) | (() => ((removeTabsConfig: LayoutTabItem[], next: () => void, safeClose?: boolean) => void) | undefined) | {
            (): ((removeTabsConfig: LayoutTabItem[], next: () => void, safeClose?: boolean) => void) | undefined;
            new (): any;
            readonly prototype: any;
        }) | null)[], unknown, unknown>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    titleKey: StringConstructor;
    childrenKey: StringConstructor;
    iconKey: StringConstructor;
    indexKey: StringConstructor;
};
export type LayoutProps = ExtractPropTypes<typeof layoutProps>;
