var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_vue2 = require("vue");
var import_lib = require("element-plus/lib/index.js");
var import_requestSelect = require("./requestSelect");
var import_base_select = require("../../base-select");
var import_pagoda_shared = require("pagoda-shared");
var import_base_select2 = require("../../base-select");
var import_lodash_unified = require("lodash-unified");
var import_pagoda_shared2 = require("pagoda-shared");
var import_utils = require("../../utils");
var import_vue3 = require("vue");
const name = (0, import_utils.createNamespace)("request-select");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ (0, import_vue.defineComponent)(__spreadProps(__spreadValues({}, __default__), {
  props: import_requestSelect.requestSelectProps,
  emits: ["visible-change", "update:modelValue"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const { t } = (0, import_lib.useLocale)();
    const baseSelectCtx = (0, import_vue2.ref)();
    const elSelectCtx = (0, import_vue2.ref)();
    const options = (0, import_vue2.ref)([]);
    const remoteQuery = (0, import_vue2.ref)("");
    const loading = (0, import_vue2.ref)(false);
    const requestError = (0, import_vue2.ref)(false);
    let lastRequest;
    const baseSelectAttrs = (0, import_pagoda_shared.usePickProps)(props, import_base_select.baseSelectProps);
    const filterMethod = (0, import_vue2.computed)(() => {
      return props.filterRemote ? handleRemote : void 0;
    });
    const filterableComputed = (0, import_vue2.computed)(() => {
      return props.remote || props.filterRemote || props.filterable;
    });
    const emptyText = (0, import_vue2.computed)(() => {
      return requestError.value ? props.errorText : props.noDataText || t("el.select.noData");
    });
    (0, import_vue2.watch)(remoteQuery, () => {
      refresh();
    });
    (0, import_vue2.watch)(
      () => props.params,
      (newVal, oldVal) => {
        if (!(0, import_lodash_unified.isEqual)(newVal, oldVal)) {
          if (props.clearOnParamsChange) {
            clear();
          }
          refresh();
        }
      },
      {
        deep: true
      }
    );
    const addNewOption = () => {
      var _a;
      if (props.bindObject && !(0, import_pagoda_shared2.isEmpty)(props.modelValue) && ((_a = remoteQuery.value) == null ? void 0 : _a.length) === 0) {
        const val = props.multiple ? props.modelValue : [props.modelValue];
        options.value = (0, import_lodash_unified.unionBy)([...options.value, ...val], (option) => {
          return option[props.valueKey];
        });
      }
    };
    const clear = () => {
      handleUpdateModelValue(props.multiple ? [] : "");
    };
    const refresh = () => __async(this, null, function* () {
      loading.value = true;
      const currentRequest = lastRequest = props.request(
        props.params,
        remoteQuery.value || ""
      );
      const ifLastRequest = (next) => {
        if (currentRequest === lastRequest) {
          next();
        }
      };
      try {
        const opts = yield currentRequest;
        ifLastRequest(() => {
          options.value = opts;
          loading.value = false;
          requestError.value = false;
          addNewOption();
        });
      } catch (e) {
        console.error(e);
        ifLastRequest(() => {
          options.value = [];
          loading.value = false;
          requestError.value = true;
          lastRequest = void 0;
        });
      }
    });
    const handleRemote = (0, import_lodash_unified.debounce)((query) => {
      remoteQuery.value = query == null ? void 0 : query.trim();
    }, 180);
    const handleVisibleChange = (visible) => {
      var _a;
      if (visible) {
        if (props.clearQueryOnFocus && ((_a = remoteQuery.value) == null ? void 0 : _a.length) !== 0) {
          remoteQuery.value = "";
        }
        if (props.refreshAfterEachFocus || (props.requestAfterFocus || requestError.value) && !lastRequest) {
          refresh();
        }
      }
      emit("visible-change", visible);
    };
    const handleUpdateModelValue = (val) => {
      emit("update:modelValue", val);
    };
    const setRef = (el) => {
      var _a;
      baseSelectCtx.value = el;
      elSelectCtx.value = (_a = baseSelectCtx.value) == null ? void 0 : _a.elSelectCtx;
    };
    (0, import_vue2.watch)(
      [() => props.autoRequest, () => props.requestAfterFocus],
      () => {
        if (props.autoRequest && !props.requestAfterFocus && !lastRequest) {
          refresh();
        }
      },
      {
        immediate: true
      }
    );
    (0, import_vue2.watch)(() => props.modelValue, addNewOption, {
      immediate: true
    });
    __expose({
      refresh,
      elSelectCtx
    });
    const __returned__ = { name, props, emit, t, baseSelectCtx, elSelectCtx, options, remoteQuery, loading, requestError, get lastRequest() {
      return lastRequest;
    }, set lastRequest(v) {
      lastRequest = v;
    }, baseSelectAttrs, filterMethod, filterableComputed, emptyText, addNewOption, clear, refresh, handleRemote, handleVisibleChange, handleUpdateModelValue, setRef, get BaseSelect() {
      return import_base_select2.BaseSelect;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return (0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["BaseSelect"], (0, import_vue3.mergeProps)({
    class: "pagoda-request-select",
    "filter-method": $setup.filterMethod
  }, $setup.baseSelectAttrs, {
    filterable: $setup.filterableComputed,
    options: $setup.options,
    loading: $setup.loading,
    "remote-method": $setup.handleRemote,
    "no-data-text": $setup.emptyText,
    onVisibleChange: $setup.handleVisibleChange,
    "onUpdate:modelValue": $setup.handleUpdateModelValue,
    ref: $setup.setRef
  }), (0, import_vue3.createSlots)({
    _: 2
    /* DYNAMIC */
  }, [
    (0, import_vue3.renderList)(_ctx.$slots, (_, slotName) => {
      return {
        name: slotName,
        fn: (0, import_vue3.withCtx)((scope) => [
          (0, import_vue3.renderSlot)(_ctx.$slots, slotName, (0, import_vue3.normalizeProps)((0, import_vue3.guardReactiveProps)(scope)))
        ])
      };
    })
  ]), 1040, ["filter-method", "filterable", "options", "loading", "remote-method", "no-data-text"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
