import type { ExtractPropTypes, EmitFn, Slots } from 'vue';
import type { TableColumnDefaultSlotProps } from './types';
import type { TableProvider } from '../../table/src/types';
export type TableColumnType = '';
export declare const tableColumnProps: {
    column: {
        readonly type: import("vue").PropType<"">;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    required: BooleanConstructor;
    reserveRadio: BooleanConstructor;
    renderColumn: {
        readonly type: import("vue").PropType<(slotProps: {
            cellValue: any;
            props: any;
            slots: Slots;
            emit: EmitFn;
            tableProvider: TableProvider;
        } & TableColumnDefaultSlotProps) => any>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    renderHeader: FunctionConstructor;
    autoMinWidth: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, boolean, boolean>;
    type: {
        type: StringConstructor;
        default: string;
    };
    label: StringConstructor;
    className: StringConstructor;
    labelClassName: StringConstructor;
    property: StringConstructor;
    prop: StringConstructor;
    width: {
        type: (NumberConstructor | StringConstructor)[];
        default: string;
    };
    minWidth: {
        type: (NumberConstructor | StringConstructor)[];
        default: string;
    };
    sortable: {
        type: (StringConstructor | BooleanConstructor)[];
        default: boolean;
    };
    sortMethod: import("vue").PropType<import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["sortMethod"]>;
    sortBy: import("vue").PropType<import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["sortBy"]>;
    resizable: {
        type: BooleanConstructor;
        default: boolean;
    };
    columnKey: StringConstructor;
    align: StringConstructor;
    headerAlign: StringConstructor;
    showOverflowTooltip: {
        type: import("vue").PropType<import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["showOverflowTooltip"]>;
        default: undefined;
    };
    fixed: (StringConstructor | BooleanConstructor)[];
    formatter: import("vue").PropType<import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["formatter"]>;
    selectable: import("vue").PropType<import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["selectable"]>;
    reserveSelection: BooleanConstructor;
    filterMethod: import("vue").PropType<import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["filterMethod"]>;
    filteredValue: import("vue").PropType<import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["filteredValue"]>;
    filters: import("vue").PropType<import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["filters"]>;
    filterPlacement: StringConstructor;
    filterMultiple: {
        type: BooleanConstructor;
        default: boolean;
    };
    filterClassName: StringConstructor;
    index: import("vue").PropType<import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["index"]>;
    sortOrders: {
        type: import("vue").PropType<import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["sortOrders"]>;
        default: () => (string | null)[];
        validator: (val: import("element-plus/es/components/table/src/table-column/defaults").TableColumnCtx<unknown>["sortOrders"]) => boolean;
    };
};
export type TableColumnProps = ExtractPropTypes<typeof tableColumnProps>;
