var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  customColumns: () => customColumns,
  default: () => stdin_default,
  extendColumnTypeCustomColumns: () => extendColumnTypeCustomColumns,
  registerColumn: () => registerColumn
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_table_column_props = require("./table-column-props");
var import_lib = require("element-plus/lib/index.js");
var import_lodash_unified = require("lodash-unified");
var import_pagoda_shared = require("pagoda-shared");
var import_utils = require("../../utils");
var import_error = require("../../utils/error");
var import_pagoda_shared2 = require("pagoda-shared");
var import_types = require("../../table/src/types");
import_lib.ElTableColumn.render = function() {
  var _a, _b, _c, _d;
  try {
    const renderDefault = (_b = (_a = this.$slots).default) == null ? void 0 : _b.call(_a, {
      row: {},
      column: {},
      $index: -1
    });
    const children = [];
    if (Array.isArray(renderDefault)) {
      for (const childNode of renderDefault) {
        if (((_c = childNode.type) == null ? void 0 : _c.name) === "ElTableColumn" || // 子节点的类型为 pagoda-table-column 时也要正常渲染
        ((_d = childNode.type) == null ? void 0 : _d.name) === "pagoda-table-column" || childNode.shapeFlag & 2) {
          children.push(childNode);
        } else if (childNode.type === import_vue.Fragment && Array.isArray(childNode.children)) {
          childNode.children.forEach((vnode2) => {
            if ((vnode2 == null ? void 0 : vnode2.patchFlag) !== 1024 && !(0, import_lodash_unified.isString)(vnode2 == null ? void 0 : vnode2.children)) {
              children.push(vnode2);
            }
          });
        }
      }
    }
    const vnode = (0, import_vue.h)("div", children);
    return vnode;
  } catch (e) {
    return (0, import_vue.h)("div", []);
  }
};
const extendColumnTypeCustomColumns = {};
const customColumns = {};
const Column = (0, import_vue.defineComponent)({
  props: (0, import_lodash_unified.omit)(import_table_column_props.tableColumnProps, ["column"]),
  setup(props, {
    slots,
    emit
  }) {
    const tableProvider = (0, import_vue.inject)(import_types.TABLE_INJECTION_KEY);
    const isAutoMinWidth = (0, import_vue.computed)(() => {
      return props.autoMinWidth && tableProvider.autoMinWidth.value;
    });
    if (props.type === "radio") {
      (0, import_vue.watch)(() => props.reserveRadio, () => {
        tableProvider.reserveRadio = props.reserveRadio;
      }, {
        immediate: true
      });
    }
    return () => {
      const elTableColumnProps = __spreadValues({}, props);
      const elTableColumnSlots = __spreadValues({}, slots);
      if (isAutoMinWidth.value && props.label) {
        const labelWidth = (0, import_pagoda_shared.getTextWidth)(props.label, '700 14px / 23px "PingFang SC", "helvetica neue", "hiragino sans gb", arial, "microsoft yahei ui", "microsoft yahei", simsun, sans-serif');
        const tableColumnPaddingLeft = 12;
        const tableColumnPaddingRight = 12;
        const requiredIconWidth = props.required ? 12 : 0;
        if (!(0, import_pagoda_shared.isNumberString)(props.minWidth) && !(0, import_pagoda_shared.isNumberExceptNaN)(props.minWidth) && !(0, import_pagoda_shared.isNumberString)(props.width) && !(0, import_pagoda_shared.isNumberExceptNaN)(props.width)) {
          elTableColumnProps.minWidth = requiredIconWidth + tableColumnPaddingLeft + labelWidth + tableColumnPaddingRight + 2;
        }
      }
      if (elTableColumnProps.renderColumn && !elTableColumnSlots.default) {
        const {
          renderColumn
        } = elTableColumnProps;
        elTableColumnSlots.default = (slotProps) => {
          const {
            row,
            column
          } = slotProps;
          const cellValue = row[column.property];
          return renderColumn(__spreadProps(__spreadValues({
            cellValue,
            props: elTableColumnProps
          }, slotProps), {
            slots,
            emit,
            tableProvider
          }));
        };
      }
      if (elTableColumnProps.renderHeader && !elTableColumnSlots.header) {
        const {
          renderHeader
        } = elTableColumnProps;
        elTableColumnSlots.header = (slotProps) => {
          return renderHeader(__spreadProps(__spreadValues({
            props: elTableColumnProps
          }, slotProps), {
            slots,
            emit
          }));
        };
      }
      if (elTableColumnProps.required) {
        const requireClass = "column-required";
        const classes = elTableColumnProps.labelClassName;
        elTableColumnProps.labelClassName = classes ? `${classes} ${requireClass}` : requireClass;
      }
      return (0, import_vue.createVNode)(import_lib.ElTableColumn, (0, import_lodash_unified.omit)(elTableColumnProps, ["renderColumn", "renderHeader"]), elTableColumnSlots);
    };
  }
});
function registerColumn(type, config, columns = customColumns) {
  if (type in columns) {
    throw new import_error.PagodaUiError("Component TableColumn", `\u5F53\u524D\u6CE8\u518C\u7684\u5217\u7C7B\u578B\u5DF2\u5B58\u5728\uFF1A${type}`);
  }
  columns[type] = {
    component: (0, import_vue.defineComponent)({
      props: (0, import_pagoda_shared2.withPropsDefaults)(Object.assign({}, Column.props, config.props), config.defaultSet || {}),
      emits: config.emits,
      setup: Column.setup
    }),
    defaultSet: config.defaultSet
  };
}
const name = (0, import_utils.createNamespace)("table-column");
var stdin_default = (0, import_vue.defineComponent)({
  name,
  props: import_table_column_props.tableColumnProps,
  registerColumn,
  setup(props, {
    slots,
    attrs
  }) {
    const instance = (0, import_vue.getCurrentInstance)();
    return () => {
      const customColumn = props.column ? customColumns[props.column] : extendColumnTypeCustomColumns[props.type];
      if (customColumn) {
        const CustomColumnComponent = customColumn.component;
        return (0, import_vue.createVNode)(CustomColumnComponent, (0, import_vue.mergeProps)(instance == null ? void 0 : instance.vnode.props, attrs), slots);
      }
      return (0, import_vue.createVNode)(Column, instance == null ? void 0 : instance.vnode.props, slots);
    };
  }
});
