var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
var stdin_exports = {};
__export(stdin_exports, {
  useTableRequest: () => useTableRequest
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
function useTableRequest({
  initialPagination,
  onRequest
}) {
  const tableData = (0, import_vue.ref)([]);
  const pagination = (0, import_vue.reactive)(
    Object.assign(
      {},
      {
        currentPage: 1,
        total: 0,
        pageSize: 10
      },
      initialPagination
    )
  );
  let tableSortable;
  function triggerRequest() {
    return __async(this, null, function* () {
      const { currentPage, pageSize } = pagination;
      const p = onRequest(currentPage, pageSize, tableSortable);
      const res = yield Promise.resolve(p);
      if (res) {
        const { data, total } = res;
        tableData.value = data;
        pagination.total = total;
      }
    });
  }
  function refresh() {
    return __async(this, null, function* () {
      pagination.currentPage = 1;
      yield refreshCurrentPage();
    });
  }
  function refreshCurrentPage() {
    return __async(this, null, function* () {
      yield triggerRequest();
    });
  }
  function setTableSortable(sortable) {
    tableSortable = sortable;
    triggerRequest();
  }
  function setPaginationSize(pageSize) {
    pagination.pageSize = pageSize;
    refresh();
  }
  function setPaginationCurrentPage(currentPage) {
    pagination.currentPage = currentPage;
    triggerRequest();
  }
  return {
    // states
    tableData,
    pagination,
    // functions
    refresh,
    refreshCurrentPage,
    setTableSortable,
    setPaginationSize,
    setPaginationCurrentPage
  };
}
