var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_vue2 = require("vue");
var import_lib = require("element-plus/lib/index.js");
var import_virtualTable = require("./virtualTable");
var import_pagoda_shared = require("pagoda-shared");
var import_lodash_unified = require("lodash-unified");
var import_pagoda_shared2 = require("pagoda-shared");
var import_lodash_unified2 = require("lodash-unified");
var import_lib2 = require("element-plus/lib/index.js");
var import_table = require("../../table");
var import_pagoda_shared3 = require("pagoda-shared");
var import_use_selection = require("./composables/use-selection");
var import_use_columns = require("./composables/use-columns");
var import_utils = require("../../utils");
var import_vue3 = require("vue");
const name = (0, import_utils.createNamespace)("virtual-table");
const __default__ = {
  name,
  inheritAttrs: false
};
const __vue_sfc__ = /* @__PURE__ */ (0, import_vue.defineComponent)(__spreadProps(__spreadValues({}, __default__), {
  props: import_virtualTable.virtualTableProps,
  emits: ["selection-change"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const slots = (0, import_vue2.useSlots)();
    const elTableV2Ctx = (0, import_vue2.ref)();
    const elTableV2Attrs = (0, import_pagoda_shared3.usePickProps)(props, import_lib.tableV2Props, {
      ignoreClassAndStyle: true
    });
    const {
      tableData,
      pagination,
      refresh,
      refreshCurrentPage,
      setPaginationCurrentPage,
      setPaginationSize
    } = (0, import_table.useTableRequest)({
      initialPagination: {
        pageSize: (0, import_pagoda_shared2.getAttrByKey)(
          props.pagination,
          "defaultPageSize"
        ) || (0, import_pagoda_shared2.getAttrByKey)(
          props.pagination,
          "pageSize"
        ) || 10
      },
      onRequest(...arg) {
        var _a, _b;
        (_a = props.onRequest) == null ? void 0 : _a.call(props, ...arg);
        return (_b = props.request) == null ? void 0 : _b.call(props, ...arg);
      }
    });
    const flexLayout = (0, import_vue2.computed)(() => {
      return Boolean(props.wrapperHeight);
    });
    const elTableHeightComputed = (0, import_vue2.computed)(() => {
      return !(0, import_pagoda_shared.isEmpty)(props.height) ? props.height : flexLayout.value ? "100%" : void 0;
    });
    const paginationConfig = (0, import_vue2.computed)(() => {
      return Object.assign(
        {
          show: true,
          layout: "total, sizes, prev, pager, next, jumper",
          background: true
        },
        {
          total: pagination.total
        },
        props.pagination
      );
    });
    const elTableSlots = (0, import_vue2.computed)(() => {
      return ["cell", "header", "header-cell", "row", "footer", "overlay"].filter(
        (name2) => slots[name2]
      );
    });
    const tableDataComputed = (0, import_vue2.computed)(() => {
      return (0, import_lodash_unified.isArray)(props.data) ? props.data : tableData.value;
    });
    const hasPagination = (0, import_vue2.computed)(() => {
      return paginationConfig.value.show && (props.request || props.onRequest);
    });
    (0, import_vue2.onBeforeMount)(() => {
      if (props.autoRequest)
        refresh();
    });
    const { orignalColumns, selectable } = (0, import_use_columns.useColumns)({
      columns: (0, import_vue2.computed)(() => props.columns),
      store: (0, import_vue2.computed)(() => {
        return __spreadValues({
          tableData: tableDataComputed
        }, selectionStore);
      })
    });
    const selectionStore = (0, import_use_selection.useSelection)({
      tableData: tableDataComputed,
      selectable,
      onSelectionChange(selection) {
        emit("selection-change", selection);
      }
    });
    __expose(__spreadProps(__spreadValues({
      elTableV2Ctx,
      tableData: tableDataComputed,
      // functions
      refresh,
      refreshCurrentPage
    }, (0, import_lodash_unified2.pick)(selectionStore, [
      "selection",
      "isAllSelected",
      "getSelectionRows",
      "clearSelection",
      "toggleAllSelection"
    ])), {
      toggleRowSelection(row, selected) {
        selectionStore.toggleRowSelection(row, selected);
        selectionStore.updateAllSelected();
      }
    }));
    const __returned__ = { name, props, emit, slots, elTableV2Ctx, elTableV2Attrs, tableData, pagination, refresh, refreshCurrentPage, setPaginationCurrentPage, setPaginationSize, flexLayout, elTableHeightComputed, paginationConfig, elTableSlots, tableDataComputed, hasPagination, orignalColumns, selectable, selectionStore, get addUnit() {
      return import_pagoda_shared.addUnit;
    }, get ElTableV2() {
      return import_lib2.ElTableV2;
    }, get ElPagination() {
      return import_lib2.ElPagination;
    }, get ElAutoResizer() {
      return import_lib2.ElAutoResizer;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
const _hoisted_1 = { class: "pagoda-virtual-table__el-virtual-table-wrapper" };
const _hoisted_2 = {
  class: "el-table__empty-block",
  style: { "height": "100%" }
};
const _hoisted_3 = { class: "el-table__empty-text" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return (0, import_vue3.openBlock)(), (0, import_vue3.createElementBlock)(
    "div",
    {
      class: (0, import_vue3.normalizeClass)(["pagoda-virtual-table", [{
        "pagoda-virtual-table--flex-column": $setup.flexLayout
      }, _ctx.$attrs.class]]),
      style: (0, import_vue3.normalizeStyle)(__spreadValues({
        height: $setup.addUnit(_ctx.wrapperHeight)
      }, _ctx.$attrs.style || {}))
    },
    [
      (0, import_vue3.createElementVNode)("div", _hoisted_1, [
        (0, import_vue3.createVNode)($setup["ElAutoResizer"], {
          style: (0, import_vue3.normalizeStyle)({ height: $setup.addUnit($setup.elTableHeightComputed) })
        }, {
          default: (0, import_vue3.withCtx)((size) => [
            (0, import_vue3.createVNode)($setup["ElTableV2"], (0, import_vue3.mergeProps)($setup.elTableV2Attrs, {
              "footer-height": !$setup.tableDataComputed.length ? 1 : _ctx.footerHeight,
              columns: $setup.orignalColumns,
              width: size.width,
              height: size.height,
              data: $setup.tableDataComputed,
              ref: "elTableV2Ctx"
            }), (0, import_vue3.createSlots)({
              empty: (0, import_vue3.withCtx)(() => [
                (0, import_vue3.renderSlot)(_ctx.$slots, "empty", {}, () => [
                  (0, import_vue3.createElementVNode)("div", _hoisted_2, [
                    (0, import_vue3.createElementVNode)(
                      "div",
                      _hoisted_3,
                      (0, import_vue3.toDisplayString)(_ctx.emptyText),
                      1
                      /* TEXT */
                    )
                  ])
                ])
              ]),
              _: 2
              /* DYNAMIC */
            }, [
              (0, import_vue3.renderList)($setup.elTableSlots, (slotName) => {
                return {
                  name: slotName,
                  fn: (0, import_vue3.withCtx)((scope) => [
                    (0, import_vue3.renderSlot)(_ctx.$slots, slotName, (0, import_vue3.normalizeProps)((0, import_vue3.guardReactiveProps)(scope)))
                  ])
                };
              })
            ]), 1040, ["footer-height", "columns", "width", "height", "data"])
          ]),
          _: 3
          /* FORWARDED */
        }, 8, ["style"])
      ]),
      (0, import_vue3.renderSlot)(_ctx.$slots, "after-table"),
      $setup.hasPagination ? ((0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["ElPagination"], (0, import_vue3.mergeProps)({ key: 0 }, $setup.paginationConfig, {
        ref: "elPaginationCtx",
        class: "pagoda-pagination",
        "current-page": $setup.pagination.currentPage,
        "onUpdate:currentPage": $setup.setPaginationCurrentPage,
        "onUpdate:pageSize": $setup.setPaginationSize
      }), null, 16, ["current-page", "onUpdate:currentPage", "onUpdate:pageSize"])) : (0, import_vue3.createCommentVNode)("v-if", true)
    ],
    6
    /* CLASS, STYLE */
  );
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
